/*
    Nakude dushata mi da byaga
    I kude da skrie svoite sulzi
*/

#include "candies.h"
#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>

typedef long long llong;
const int MAXN = 200000 + 10;
const int MAXLOG = 18;
const int INF = 1e9;

int n;
// int s[MAXN];
// int c[MAXN];
llong p[MAXN];
llong b[MAXN];
llong a[MAXN];
void init(std::vector <int> A, std::vector <int> B)
{
    n = A.size();
    for (int i = 1 ; i <= n ; ++i)
    {
        a[i] = A[i - 1];
        b[i] = B[i - 1];
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        p[i] = b[i] - a[i] + p[i - 1];
    }
}

bool isValid(int l, int r)
{
    l++; r++;
    // std::cout << "here2: " << p[r] - p[l - 1] << '\n'; 
    if (p[r] - p[l - 1] < 0)
    {
        return 0;
    }

    llong minStart = 1e18;
    for (int i = l ; i <= r ; ++i)
    {
        if (p[i] + minStart < 0)
        {
            return 0;
        }

        minStart = std::min(minStart, b[i] - p[i]);
    }

    minStart = 1e18;
    for (int i = r ; i >= l ; --i)
    {
        if (p[i] + minStart + p[r] - p[l - 1] < 0)
        {
            return 0;
        }

        minStart = std::min(minStart, b[i] - p[i]);
    }

    return true;
}

void update(int l, int r, int x, int y)
{
    l++; r++;
    for (int i = l ; i <= r ; ++i)
    {
        a[i] = x;
        b[i] = y;
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        p[i] = b[i] - a[i] + p[i - 1];
    }
}