/*
    Nakude dushata mi da byaga
    I kude da skrie svoite sulzi
*/

#include "candies.h"
#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>

typedef long long llong;
const int MAXN = 200000 + 10;
const int MAXLOG = 18;
const int INF = 1e9;

int n;
int a[MAXN];
int b[MAXN];
// int s[MAXN];
// int c[MAXN];
void init(std::vector <int> A, std::vector <int> B)
{
    n = A.size();
    for (int i = 1 ; i <= n ; ++i)
    {
        a[i] = A[i - 1];
        b[i] = B[i - 1];
    }
}

bool isValid(int l, int r)
{
    l++; r++;
    int start = l;
    llong maxPrefix = a[l] - b[l];
    llong prefix = a[l] - b[l];
    for (int i = l + 1 ; i <= r ; ++i)
    {
        prefix += a[i] - b[i];
        if (prefix > maxPrefix)
        {
            start = i;
        }
    }

    // std::cout << "min: " << min << '\n';
    std::vector <int> vals;
    vals.push_back(l);
    vals.push_back(r);
    vals.push_back(start);

    for (const int &start : vals)
    {
        bool isOK = true;
        llong taken = 0;
        for (int i = start ; i >= l && isOK ; --i)
        {
            if (taken > b[i])
            {
                isOK = false;
            }

            taken = std::max(0LL, a[i] + taken - b[i]);
        }

        for (int i = r ; i > start && isOK ; --i)
        {
            if (taken > b[i])
            {
                isOK = false;
            }

            taken = std::max(0LL, a[i] + taken - b[i]);
        }
    
        if (isOK && taken == 0)
        {
            return true;
        }
    }

    return false;
}

void update(int l, int r, int x, int y)
{
    l++; r++;
    for (int i = l ; i <= r ; ++i)
    {
        a[i] = x;
        b[i] = y;
    }
}