/*
    Nakude dushata mi da byaga
    I kude da skrie svoite sulzi
*/

#include "candies.h"
#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>

typedef long long llong;
const int MAXN = 200000 + 10;
const int MAXLOG = 18;
const int INF = 1e9;

int n;
llong a[MAXN];
llong b[MAXN];
// int s[MAXN];
// int c[MAXN];
void init(std::vector <int> A, std::vector <int> B)
{
    n = A.size();
    for (int i = 1 ; i <= n ; ++i)
    {
        a[i] = A[i - 1];
        b[i] = B[i - 1];
    }
}

bool isValid(int l, int r)
{
    l++; r++;
    int start = r;
    llong maxPrefix = a[r] - b[r];
    llong prefix = a[r] - b[r];

    for (int i = r - 1 ; i >= l ; --i)
    {
        prefix += a[i] - b[i];
        if (prefix >= maxPrefix)
        {
            start = i;
        }
    }

    // std::cout << "min: " << min << '\n';
    llong taken = 0;
    for (int i = start ; i >= l ; --i)
    {
        if (taken > b[i])
        {
            return false;
        }

        taken = std::max(0LL, a[i] + taken - b[i]);
    }

    for (int i = r ; i > start ; --i)
    {
        if (taken > b[i])
        {
            return false;
        }

        taken = std::max(0LL, a[i] + taken - b[i]);
    }

    return (taken == 0);
}

void update(int l, int r, int x, int y)
{
    l++; r++;
    for (int i = l ; i <= r ; ++i)
    {
        a[i] = x;
        b[i] = y;
    }
}