#include "pointsort.h"
#include<bits/stdc++.h>

#define MAXN 10007
using namespace std;

int nn,kk,ind;
vector<int> perm[MAXN],g[MAXN];

vector<int> v[MAXN][5];
int deg[MAXN][5];

vector<bool> res[10][MAXN];
int currind;

bool cmp(int x,int y){
    auto res=compare(x,y);

    for(int i=0;i<kk;i++){
        if(res[i]){v[y][i].push_back(x); deg[x][i]++;}
        else {v[x][i].push_back(y); deg[y][i]++;}
    }

    return res[currind];
}

vector<int> bfs(int x,int ind){
    vector<int> res;

    for(int i:v[x][ind]){
        deg[i][ind]--;

        if(deg[i][ind]==0)res.push_back(i);
    }

    return res;
}

int order(vector<int> t,int ind){
    currind=ind;

    sort(t.begin(),t.end(),cmp);
    reverse(t.begin(),t.end());

    for(int i=0;i<int(t.size())-1;i++){
        v[t[i]][ind].push_back(t[i+1]);
        deg[t[i+1]][ind]++;
    }

    return t[0];
}

vector< vector<int> > pointSort(int N, int K){
    nn=N; kk=K;

    vector<int> s;
    for(int i=0;i<nn;i++)s.push_back(i);

    currind=0;
    sort(s.begin(),s.end(),cmp);

    for(int i=0;i<s.size();i++){
        perm[s[i]].push_back(i);
    }

    for(int i=1;i<kk;i++){
        vector<int> w;
        int num=nn-1;

        for(int f=0;f<nn;f++){
            if(deg[f][i]==0)w.push_back(f);
        }

        while(!w.empty()){

            if(w.size()>1){
                w={order(w,i)};
                while(w.size()>1)w.pop_back();
            }

            perm[w[0]].push_back(num); num--;
            w=bfs(w[0],i);
        }
    }

    vector< vector<int> > ans;
    for(int i=0;i<nn;i++)ans.push_back(perm[i]);

    return ans;
}