#include "pointsort.h"
#include<bits/stdc++.h>

#define MAXN 10007
using namespace std;

int nn,kk,ind;
vector<int> perm[MAXN],g[MAXN];

vector<bool> res[10][MAXN];

void solve(int ind,vector<int> s,int l,int r){

    if(s.empty())return;
    if(l==r){
        perm[s[0]].push_back(l);
        return;
    }

    vector<int> ll,rr;

    int pivot=s[0];

    for(int i:s){
        if(i==pivot)continue;

        if(compare(pivot,i)[ind]){
            rr.push_back(i);
        }else{
            ll.push_back(i);
        }
    }


    int sz=int(ll.size());
    perm[pivot].push_back(l+sz);

    solve(ind,ll,l,l+sz-1);
    solve(ind,rr,l+sz+1,r);
}

int lg[MAXN];

vector< vector<int> > pointSort(int N, int K){
    nn=N; kk=K;

    for(int i=2;i<=nn;i++)lg[i]=lg[i/2]+1;
    for(int i=1;i<=nn;i++)lg[i]++;

    int oper=kk*nn*lg[nn];

    int best=1;
    for(int c=1;c<=20;c++){
        int curr=c*nn + kk*nn*lg[nn/(c+1)];
        if(curr<oper){
            oper=curr;
            best=c;
        }
    }

    vector<int> s;
    for(int i=0;i<nn;i++){
        s.push_back(i);
        perm[i].clear();
    }

    for(int i=0;i<best;i++){
        perm[i].resize(kk);

        for(int f=0;f<nn;f++){
            if(i==f)continue;

            res[i][f]=compare(i,f);

            for(int z=0;z<kk;z++){
                if(!res[i][f][z])perm[i][z]++;
            }
        }
    }

    for(int i=0;i<kk;i++){
        for(int t=0;t<best+1;t++)g[t].clear();

        for(int f=best;f<nn;f++){
            int group=0;

            for(int k=0;k<best;k++){
                if(res[k][f][i])group++;
            }

            g[group].push_back(f);
        }

        int pref=0;
        for(int t=0;t<best+1;t++){

            solve(i,g[t],pref,pref+int(g[t].size())-1);
            pref+=int(g[t].size()); pref++;
        }
    }

    vector< vector<int> > ans;
    for(int i=0;i<nn;i++)ans.push_back(perm[i]);

    return ans;
}