#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const ll MAXN = 1e5 + 10;

int n, m;
vector < ll > basket[MAXN];
pair < ll, ll > task[MAXN];
void input()
{
    cin >> n >> m;
    for (int i = 1; i <= m; i ++)
    {
        int k;
        cin >> k;
        basket[i].resize(k);
        for (int j = 0; j < k; j ++)
            cin >> basket[i][j];
    }
}

unordered_map < ll, ll > sum_small;

vector < int > belongs[MAXN];

void small_baskets()
{
    int s = 80;
    for (int i = 1; i <= m; i ++)
    {
        int k = basket[i].size();
        if (k > s)
        {
            for (int j = 0; j < k; j ++)
                belongs[basket[i][j]].push_back(i);
            continue;
        }
        for (int j = 0; j < k; j ++)
            for (int d = 0; d < k; d ++)
        {
            if (basket[i][j] >= basket[i][d])
                continue;

            sum_small[{basket[i][j] * MAXN +  basket[i][d]}] += (ll)(i);
        }
    }
}

void answer_queries()
{
    int q;
    cin >> q;
    for (int i = 1; i <= q; i ++)
    {
        ll a, b;
        cin >> a >> b;
        if (a > b)
            swap(a, b);

        ll aux = 0;
        int pivot = 0;
        for (ll x : belongs[a])
        {
            while(pivot < (int)belongs[b].size() && belongs[b][pivot] < x)
            {
                pivot ++;
            }
            if (pivot < (int)belongs[b].size() && belongs[b][pivot] == x)
                aux += x;
        }
        cout << aux + sum_small[a * MAXN + b] << endl;
    }
}
void solve()
{
    input();
    small_baskets();
    answer_queries();

}

int main()
{
    speed();
    solve();
    return 0;
}
