#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const ll MAXN = 1e5 + 10;

int n, m, q;
vector < ll > basket[MAXN];

unordered_map < ll, int > idx;

pair < ll, ll > task[MAXN];
ll res[MAXN];


void input()
{
    cin >> n >> m;
    for (int i = 1; i <= m; i ++)
    {
        int k;
        cin >> k;
        basket[i].resize(k);
        for (int j = 0; j < k; j ++)
            cin >> basket[i][j];
    }
    cin >> q;

    for (int i = 1; i <= q; i ++)
    {
        cin >> task[i].first >> task[i].second;
        if (task[i].first > task[i].second)
            swap(task[i].first,  task[i].second);
        idx[task[i].first * MAXN + task[i].second] = i;
    }
}


void small_baskets()
{
    for (int i = 1; i <= m; i ++)
    {
        int k = basket[i].size();
        for (int j = 0; j < k; j ++)
            for (int d = 0; d < k; d ++)
        {
            if (basket[i][j] >= basket[i][d])
                continue;

            res[idx[basket[i][j] * MAXN + basket[i][d]]] += (ll)(i);
        }
    }
}

void answer_queries()
{
    for (int i = 1; i <= q; i ++)
    {
        cout << res[i] << endl;
    }
}
void solve()
{
    input();
    small_baskets();
    answer_queries();

}

int main()
{
    speed();
    solve();
    return 0;
}

/**


*/
