#include<bits/stdc++.h>
#include "pointsort.h"

using namespace std;
typedef long long ll;

const int MAXN = 1e4 + 10;

int cur_cor;


const int MAXK = 5;


vector < vector < int > > Points;
bool inserted[MAXK];
int pos[MAXK][MAXN], l[MAXK], r[MAXK], lg[MAXN];

int choose_m(int k, int i)
{
    int pivot = -1;
    double best = 1e9;
    for (int j = 0; j < i; j ++)
    {
        double sum = 0;
        for (int c = 0; c < k; c ++)
        {
            int cur_l = l[c], cur_r = r[c];
            int m = pos[c][j];

            if (m <= cur_l || m >= cur_r)
            {
                sum += lg[cur_r - cur_l - 1];
                continue;
            }

            int len1 = (m - cur_l - 1);
            int len2 = (cur_r - m - 1);
            if (len1 + len2 == 0)
                continue;
            double cont = ((double)(len1) * (double)lg[len1] + (double)(len2) * (double)(lg[len2]));
            cont /= (double)(len1 + len2);
            sum += cont;
        }
        if (sum < best)
        {
            pivot = j;
            best = sum;
        }
    }
    assert(i == 0 || pivot != -1);
    /**cout << "-------------" << endl;
    int j = pivot, sum = 0;
        for (int c = 0; c < k; c ++)
    {
        int cur_l = l[c], cur_r = r[c];
        int m = pos[c][j];

        if (m <= cur_l || m >= cur_r)
        {
            sum += 2 * lg[cur_r - cur_l - 1];
            continue;
        }

        int len1 = (m - cur_l - 1);
        int len2 = (cur_r - m - 1);

        sum += lg[len1] + lg[len2];
        cout << len1 << " : " << len2 << " = " << lg[len1] << " " << lg[len2] << " all " << sum << endl;
    }*/
    ///cout << "here " << pivot << " " << best << endl;
    return pivot;
}
vector < vector < int > > pointSort(int n, int k)
{
    for (int i = 1; i <= n + 2; i ++)
    {
        lg[i] = lg[i / 2] + 1;
    }
    Points.clear();
    Points.resize(n);
    for (int i = 0; i < n; i ++)
        Points[i].resize(k);

    vector < int > ord[MAXK];
    int cmp_count = 0;
    for (int i = 0; i < n; i ++)
    {
        ///cout << i << " " << cmp_count << endl;
        for (int c = 0; c < k; c ++)
        {
            inserted[c] = false;
            for (int j = 0; j < (int)(ord[c].size()); j ++)
            {
                pos[c][ord[c][j]] = j;
            }
            l[c] = -1;
            r[c] = (int)(ord[c].size());
        }
        bool notDone = true;


        while(notDone)
        {
            notDone = false;

            int ver = choose_m(k, i);
            vector < bool > check;
            cmp_count ++;
            for (int c = 0; c < k; c ++)
            {
                if (inserted[c])
                    continue;
                if (l[c] + 1 >= r[c])
                {
                    inserted[c] = true;
                    ord[c].insert(ord[c].begin() + r[c], i);

                    continue;
                }
                notDone = true;


                if (check.empty())
                    check = compare(ver, i);
                int m = pos[c][ver];


                if (check[c] == 1)
                    l[c] = max(l[c], m);
                else
                    r[c] = min(r[c], m);
            }
        }

    }

    for (int c = 0; c < k; c ++)
    {
        for (int i = 0; i < n; i ++)
            Points[ord[c][i]][c] = i;
    }
    return Points;
}
