#include<bits/stdc++.h>

using namespace std;
typedef long long ll;

const int MAXN = 2e5 + 10;

int n, a[MAXN], b[MAXN];

void init(vector < int > kids, vector < int > candies)
{
    n = kids.size();
    for (int i = 0; i < n; i ++)
    {
        a[i] = kids[i];
        b[i] = candies[i];
    }
}

bool isValid(int l, int r)
{
    int max_to = l - 1;
    for (int i = l; i <= r; i ++)
    {
        if (i <= max_to)
            continue;

        int t = i, can_take = 0, steps = 0;
        while(true)
        {
            if (b[t] + can_take < a[t])
                break;
            steps ++;
            can_take = b[t] - max(0, (a[t] - can_take));

            t ++;
            if (t > r)
                t = l;

            if (t == i)
                break;
        }

        if (steps == (r - l + 1))
            return true;
    }

    return false;
}

void update(int l, int r, int x, int y)
{
    for (int i = l; i <= r; i ++)
    {
        a[i] = x;
        b[i] = y;
    }
}
