#include<iostream>
#include<algorithm>
#include<vector>
using namespace std;
const int MAX_N=1e5+2;
const int MAX_R=320;
long long sumbig[MAX_R][MAX_N];
int n,m;
vector<int>mushroom[MAX_N];
bool used[MAX_N];
int wh[MAX_N];
int main ()
{
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n>>m;
    for(int i=1;i<=m;i++)
    {
        int k;
        cin>>k;
        for(int j=1;j<=k;j++)
        {
            int x;
            cin>>x;
            mushroom[x].push_back(i);
        }
    }

    for(int i=1;i<=n;i++)
    {
        sort(mushroom[i].begin(),mushroom[i].end());
    }

    int szbig=0;

    for(int i=1;i<=n;i++)
    {
        if(mushroom[i].size()<=MAX_R)continue;

        for(int&j:mushroom[i])used[j]=1;

        for(int j=1;j<=n;j++)
        {
            for(int&basket:mushroom[j])
            {
                sumbig[szbig][j]+=(used[basket] ? basket : 0);
            }
        }

        for(int&j:mushroom[i])used[j]=0;

        wh[i]=szbig;
        szbig++;
    }

    int q;
    cin>>q;
    while(q--)
    {
        int a,b;
        cin>>a>>b;
        if(mushroom[a].size()>mushroom[b].size())swap(a,b);
        if(mushroom[b].size()>MAX_R)
        {
            cout<<sumbig[wh[b]][a]<<"\n";
            continue;
        }

        if(mushroom[b].size()==0)
        {
            cout<<0<<"\n";
            continue;
        }

        long long ans=0;
        int id=0;
        for(int&basket:mushroom[a])
        {
            while(id+1<mushroom[b].size() && mushroom[b][id]<basket)id++;
            if(mushroom[b][id]==basket)ans+=basket;
        }
        cout<<ans<<"\n";
    }


    return 0;
}
