#include<iostream>
#include<algorithm>
#include<vector>
#include<bitset>
#include<queue>
#include<random>
#include<chrono>
#include "pointsort.h"
using namespace std;
const int MAX_N=1e3;
bool used[MAX_N][MAX_N];
//bitset<10000>used[MAX_N];
vector<int>g[5][MAX_N];
int in[5][MAX_N];
int tmp[5][MAX_N];
int N,K;
vector<vector<int>>ans;
vector<int>q;
int sz;
void query(int i,int j)
{
    if(used[i][j])return;

    used[i][j]=1;
    used[j][i]=1;

    auto ss=compare(i,j);

    for(int d=0;d<K;d++)
    {
        if(ss[d]==1)
        {
            in[d][j]++;
            g[d][i].push_back(j);
        }
        else
        {
            in[d][i]++;
            g[d][j].push_back(i);
        }
    }
}
void doit(int d)
{
    int u=-1;

    sz=0;

    for(int i=0;i<N;++i)
    {
        tmp[d][i]=in[d][i];
        if(tmp[d][i]==0)
        {
            u=i;
        }
    }

    int aux;

    while(u!=-1)
    {
        aux=u;
        u=-1;
        ans[aux][d]=sz++;
        for(int&v:g[d][aux])
        {
            if(--tmp[d][v]==0)u=v;
        }
    }
}
int u,i;
bool okthis(int d)
{
    q.clear();

    for(i=0;i<N;++i)
    {
        tmp[d][i]=in[d][i];
        if(tmp[d][i]==0)
        {
            q.push_back(i);
        }
    }

    while(q.size())
    {
        if(q.size()>1)
        {
            for(i=1;i<q.size();i++)query(q[i-1],q[i]);

            return 0;
        }

        u=q[0];
        q.clear();

        for(int&v:g[d][u])
        {
            if(--tmp[d][v]==0)q.push_back(v);
        }
    }

    return 1;
}
bool okall()
{
    for(int pro=0;pro<K;pro++)
    {
        if(!okthis(pro))return 0;
    }
    return 1;
}
vector<vector<int>> pointSort(int n, int k)
{
    N=n;
    K=k;

    for(int d=0;d<K;d++)
    {
        for(int i=0;i<N;i++)
        {
            g[d][i].clear();
            in[d][i]=0;
        }
    }

    for(int i=0;i<N-1;i++)
    {
        query(i,i+1);
    }

    while(okall()==0);

    ans.clear();

    ans.resize(N);

    for(int i=0;i<N;i++)ans[i].resize(K);

    for(int d=0;d<K;d++)doit(d);

    /*for(int i=0;i<N;i++)
    {
        for(int d=0;d<K;d++)
        {
            cout<<ans[i][d]<<" ";
        }
        cout<<"\n";
    }*/

    return ans;
}
