#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXM=50005, MAXN=100025;
vector<unsigned short> mask[MAXN];


const int MAXSZ=(1<<16);
int brb[MAXSZ], val[MAXSZ];

void fill_bt()
{
    for(int i=0; i<(1<<16); i++)
    {
        for(int j=0; j<16; j++)
        {
            if(i & (1<<j))
            {
                brb[i]++;
                val[i]+=j;
            }
        }
    }
}


const int BLK=300;
int K[MAXM];
vector<int> gb[MAXM];
int cnt_sr[MAXN];

vector<int> ksh[MAXN];

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    fill_bt();

    int n, m;
    cin>>n>>m;
    for(int i=1; i<=m; i++)
    {
        cin>>K[i];
        gb[i].resize(K[i]);
        for(int j=0; j<K[i]; j++) 
        {
            cin>>gb[i][j];
            cnt_sr[gb[i][j]]++;
        }
    }
    for(int i=1; i<=n; i++) if(cnt_sr[i]>=BLK) mask[i].resize(MAXM/16+5);

    for(int i=1; i<=m; i++)
    {
        for(int j=0; j<K[i]; j++) 
        {
            if(cnt_sr[gb[i][j]]<BLK) ksh[gb[i][j]].push_back(i);
            else mask[gb[i][j]][i/16]^=(1<<(i%16));
        }
    }

    int q;
    cin>>q;

    for(int i=0; i<q; i++)
    {
        int u, v;
        long long ans=0;
        cin>>u>>v;
        if(cnt_sr[u]>cnt_sr[v]) swap(u, v);

        if(cnt_sr[u]>=BLK)
        {
            for(int j=0; j<=m/16; j++)
            {
                int sts=(mask[u][j]&mask[v][j]);
                ans+=(long long)j*16*brb[sts]+val[sts];
            }
            cout<<ans<<endl;
        }
        else if(cnt_sr[v]>=BLK)
        {
            for(int j=0; j<cnt_sr[u]; j++)
            {
                int tek=ksh[u][j];
                if(mask[v][tek/16]&(1<<(tek%16))) ans+=tek;
            }
            cout<<ans<<endl;
        }
        else
        {
            int idu=0, idv=0;
            while(idu<cnt_sr[u] && idv<cnt_sr[v])
            {
                if(ksh[u][idu]==ksh[v][idv])
                {
                    ans+=ksh[u][idu];
                    idu++;
                    idv++;
                }
                else if(ksh[u][idu]<ksh[v][idv]) idu++;
                else idv++;
            }
            cout<<ans<<endl;
        }           
    }

    return 0;
}