#include "pointsort.h"
#include<bits/stdc++.h>

using namespace std;

std::vector<std::vector<int>> pointSort(int n, int k)
{
    vector<vector<int> > srtr, ansr;
    int tekind[10005][6];

    srtr.resize(n);
    for(int i=0; i<n; i++) srtr[i].resize(k);

    ansr.resize(n);
    for(int i=0; i<n; i++) ansr[i].resize(k);

    for(int d=0; d<k; d++) {srtr[0][d]=0; tekind[0][d]=0;}
    
    for(int i=1; i<n; i++)
    {
        unordered_map<int, vector<bool>> mmr;

        for(int d=0; d<k; d++)
        {
            int le=-1, ri=i;
            for(unordered_map<int, vector<bool>>::iterator it=mmr.begin(); it!=mmr.end(); it++)
            {
                if((*it).second[d]==0) le=max(le, tekind[(*it).first][d]);
                else ri=min(ri, tekind[(*it).first][d]);
            }
            while(ri-le>1)
            {
                int mid=(le+ri)/2;
                mmr[srtr[mid][d]]=compare(i, srtr[mid][d]);
                if(mmr[srtr[mid][d]][d]==0) le=mid;
                else ri=mid;
            }
            for(int j=i; j>le+1; j--) 
            {
                swap(srtr[j][d], srtr[j-1][d]);
                tekind[srtr[j][d]][d]++;
            }
            srtr[le+1][d]=i;
            tekind[i][d]=le+1;
        }
    }

    for(int i=0; i<n; i++)
    {
        for(int d=0; d<k; d++) ansr[srtr[i][d]][d]=i;
    }
    return ansr;
}
