#include "pointsort.h"
#include<bits/stdc++.h>

using namespace std;

const int MAXN=10000;

int n,k;
bitset<MAXN> cmp[5][MAXN];
bool used[MAXN][MAXN];
vector<int> v;
int cur=0;
vector<int> tmp;
bool cru[MAXN];

bool comp(int x,int y)
{
    bool fl=0;
    if(x<y)
    {
        swap(x,y);
        fl=1;
    }
    if(used[x][y])
    {
        if(cmp[cur][x][y]==0) return 0^fl;
        else if(cmp[cur][x][y]==1) return 1^fl;
    }
    else
    {
        used[x][y]=1;
        vector<bool> c=compare(x,y);
        for(int i=0;i<k;i++)
        {
            if(c[i]==0) 
            {
                cmp[i][x][y]=0;
                //cmp[y][x][i]=2;
            }
            else
            {
                cmp[i][x][y]=1;
                //cmp[y][x][i]=1;
            }
        }
        if(cmp[cur][x][y]==0) return 0^fl;
        else return 1^fl;
    }
}

void mergeSort(int l,int r)
{
    //cout<<l<<" "<<r<<" ";
    if(l>=r) return;

    int mid=(l+r)/2;
    mergeSort(l,mid);
    mergeSort(mid+1,r);

    tmp.clear();
    int ptrl=l, ptrr=mid+1;
    while(ptrl<=mid && ptrr<=r)
    {
        if(comp(v[ptrl],v[ptrr]))
        {
            tmp.push_back(v[ptrl]);
            ptrl++;
        }
        else
        {
            tmp.push_back(v[ptrr]);
            ptrr++;
        }
    }
    while(ptrl<=mid)
    {
        tmp.push_back(v[ptrl]);
        ptrl++;
    }
    while(ptrr<=r)
    {
        tmp.push_back(v[ptrr]);
        ptrr++;
    }

    for(int i=l;i<=r;i++) v[i]=tmp[i-l];
}

int cnt[MAXN];
bool cmpV(int x,int y)
{
    return cnt[x]<cnt[y];
}

std::vector<std::vector<int>> pointSort(int _n, int _k)
{
    n=_n;
    k=_k;
    for(int h=0;h<k;h++)
    {
        for(int i=0;i<n;i++)
        {
            for(int j=0;j<i;j++)
            {
                cmp[h][i][j]=0;
            }
        }
    }
    for(int i=0;i<n;i++)
    {
        for(int j=0;j<i;j++) used[i][j]=0;
    }

    vector<vector<int> > ans;
    ans.resize(n);
    for(int i=0;i<n;i++) ans[i].resize(k);

    v.resize(n,0);
    tmp.reserve(n);
    for(int i=0;i<k;i++)
    {
        cur=i;
        for(int j=0;j<n;j++) cnt[j]=0;
        for(int j=0;j<n;j++)
        {
            for(int h=0;h<j;h++)
            {
                if(used[j][h])
                {
                    if(cmp[cur][j][h]==0)
                    {
                        cnt[j]--;
                        cnt[h]++;
                    }
                }
            }
        }
        sort(v.begin(), v.end(), cmpV);
        mergeSort(0,n-1);
//cout<<endl<<i<<endl;
        for(int j=0;j<n;j++)
        {
            ans[v[j]][i]=j;
        }
    }

    return ans;
}