#pragma GCC optimize("Ofast")
#include "pointsort.h"
#include<bits/stdc++.h>

using namespace std;

const int MAXN=10000;

int n,k;
bitset<MAXN> cmp[5][MAXN];
bool used[MAXN][MAXN];
vector<int> v;
int cur=0;
vector<int> tmpl;
vector<int> tmpr;

bool comp(int x,int y)
{
    bool fl=0;
    if(x<y)
    {
        swap(x,y);
        fl=1;
    }
    if(used[x][y])
    {
        if(cmp[cur][x][y]==0) return 0^fl;
        else if(cmp[cur][x][y]==1) return 1^fl;
    }
    else
    {
        used[x][y]=1;
        vector<bool> c=compare(x,y);
        for(int i=0;i<k;i++)
        {
            if(c[i]==0) 
            {
                cmp[i][x][y]=0;
                //cmp[y][x][i]=2;
            }
            else
            {
                cmp[i][x][y]=1;
                //cmp[y][x][i]=1;
            }
        }
        if(cmp[cur][x][y]==0) return 0^fl;
        else return 1^fl;
    }
}

void quickSort(int l,int r)
{
    //cout<<l<<" "<<r<<" ";
    if(l>=r) return;

    int ind=l+rand()%(r-l+1);
    tmpl.clear();
    tmpr.clear();
    for(int i=l;i<=r;i++)
    {
        if(i==ind) continue;
        if(comp(v[i],v[ind])) tmpl.push_back(v[i]);
        else tmpr.push_back(v[i]);
    }

    int t=v[ind];
    for(int i=0;i<tmpl.size();i++) v[l+i]=tmpl[i];
    v[l+tmpl.size()]=t;
    for(int i=0;i<tmpr.size();i++) v[l+tmpl.size()+1+i]=tmpr[i];

    quickSort(l, l+tmpl.size()-1);
    quickSort(l+tmpl.size()+1, r);
}

std::vector<std::vector<int>> pointSort(int _n, int _k)
{
    n=_n;
    k=_k;
    for(int h=0;h<k;h++)
    {
        for(int i=0;i<n;i++)
        {
            for(int j=0;j<i;j++)
            {
                cmp[h][i][j]=0;
            }
        }
    }
    for(int i=0;i<n;i++)
    {
        for(int j=0;j<i;j++) used[i][j]=0;
    }

    vector<vector<int> > ans;
    ans.resize(n);
    for(int i=0;i<n;i++) ans[i].resize(k);

    v.resize(n,0);
    tmpl.reserve(n);
    tmpr.reserve(n);
    for(int i=0;i<k;i++)
    {
        for(int j=0;j<n;j++) v[j]=j;
        cur=i;
        quickSort(0,n-1);
//cout<<endl<<i<<endl;
        for(int j=0;j<n;j++)
        {
            ans[v[j]][i]=j;
        }
    }

    return ans;
}