#include "candies.h"
#include<bits/stdc++.h>

using namespace std;

const int MAXN=2e5+5;

int n;
int a[MAXN];
int b[MAXN];
int a1[MAXN];
int b1[MAXN];

void init(std::vector<int> kids, const std::vector<int> candies)
{
    n=kids.size();
    for(int i=0;i<n;i++)
    {
        a[i+1]=kids[i];
        b[i+1]=candies[i];
    }
}

bool isValid(int l, int r)
{
    l++, r++;
    if(l==r) return a[l]<=b[l];
    for(int i=l;i<=r;i++)
    {
        a1[i]=a[i];
        b1[i]=b[i];
    }
    int x=min(a1[r], b1[r-1]);
    a1[r]-=x;
    b1[r-1]-=x;
    if(a1[r]>0)
    {
        x=min(a1[r], b1[r]);
        a1[r]-=x;
        b1[r]-=x;
        if(a1[r]>0) return 0;
    }
    for(int i=r-1;i>=l;i--)
    {
        int x=min(a1[i], b1[i]);
        a1[i]-=x;
        b1[i]-=x;
        if(a1[i]>0)
        {
            if(i>l)
            {
                x=min(a1[i], b1[i-1]);
                a1[i]-=x;
                b1[i-1]-=x;
                if(a1[i]>0) return 0;
            }
            else
            {
                x=min(a1[i], b1[r]);
                a1[i]-=x;
                b1[r]-=x;
                if(a1[i]>0) return 0;
            }
        }
    }
    return 1;
}

void update(int l, int r, int x, int y)
{
    l++, r++;
    for(int i=l;i<=r;i++)
    {
        a[i]=x;
        b[i]=y;
    }
}