#define ll int

#include<bits/stdc++.h>
using namespace std;

const ll MAXN=1e5+1;
ll n,m,ans,a,b;
vector<ll> v[MAXN/2];
bitset<MAXN/4> tree1[MAXN*2],tree2[MAXN*2];

void build(ll k, ll l, ll r){
    if(l==r){
        for(auto i : v[l]) tree1[k][i]=tree2[k][i]=1;
        return;
    }

    ll mid=(l+r)/2;
    build(k*2,l,mid);
    build(k*2+1,mid+1,r);

    tree1[k]=tree1[k*2]&tree1[k*2+1];
    tree2[k]=tree2[k*2]|tree2[k*2+1];
}

void query(ll k, ll l, ll r){
    if(tree2[k][a]==0 || tree2[k][b]==0) return;
    if(tree1[k][a]==1 && tree1[k][b]==1){
        ans+=r*(r+1)/2-l*(l-1)/2;
        return;
    }

    ll mid=(l+r)/2;
    query(k*2,l,mid);
    query(k*2+1,mid+1,r);
}

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(NULL);

    cin>>n>>m;
    ll k,g;
    for(ll i=1;i<=m;i++){
        cin>>k;
        for(ll j=0;j<k;j++){
            cin>>g;
            v[i].push_back(g);
        }
    }

    build(1,1,m);

    ll q;
    cin>>q;
    while(q--){
        cin>>a>>b;
        ans=0;
        query(1,1,m);
        cout<<ans<<'\n';
    }

    return 0;
}
