#include "pointsort.h"
#include <algorithm>
#include <iostream>
#include <bits/stdc++.h>
using namespace std;

template< class T, class T2 > inline bool chkmin( T& a, const T2&b ){ return a > b ? a = b, 1 : 0;}
template< class T, class T2 > inline bool chkmax( T& a, const T2&b ){ return a < b ? a = b, 1 : 0;}


#ifndef LOCAL
#define cerr if( false ) cerr
#endif // LOCAL

#define out( x ) #x << " = " << x << "  "
#define endld "\n"

typedef long long ll;

const int MAX_N = 1e4 + 42;
const int mod = 1e7 + 9;

















std::map< std::pair< int, int >, std::vector< bool > > query;
std::vector< bool > makeQ( int a, int b ){
    if( a > b ) std::swap( a, b );
    std::pair< int, int > ab = std::make_pair( a, b );
    if( query.find(ab) == query.end() ){
        query[ab] = compare( a, b );
    }
    return query[ab];
}

void sol( int kk, int l, int r, std::vector< int >& v ){

    cerr << out( l ) << out( r ) << endl;
        cerr << "v " << endl;
    for( auto j : v ) cerr << j <<" ";
    cerr << endl;


    if( l == r ) return;
    int m = ( l + r ) >> 1;

    std::vector< int > left, right;
    for( int i=l ; i <= r ; i++ ){
        cerr << out( i ) << out( v[i-l] ) << endl;
        if( i <= m ) left.push_back( v[i-l] );
        else right.push_back( v[i-l] );
    }



    cerr << " left " << endl;
    for( auto j : left ) cerr << j <<" ";
    cerr << endl;

    cerr << " right " << endl;
    for( auto j : right ) cerr << j <<" ";
    cerr << endl << endl;


    sol( kk, l, m, left );
    sol( kk, m+1, r, right );

    int ind1, ind2;
    ind1 = ind2 = 0;
    int A = left.size();
    int B = right.size();


    cerr << " left " << endl;
    for( auto j : left ) cerr << j <<" ";
    cerr << endl;

    cerr << " right " << endl;
    for( auto j : right ) cerr << j <<" ";
    cerr << endl << endl;
    std::vector< int > nas;
    while( ind1 < A || ind2 < B ){

        cerr << out( ind1 ) << out( ind2 ) << endl;
        if( ind1 == A ){
            nas.push_back( right[ind2] );
            ind2 ++;
            continue;
        }
        if( ind2 == B ){
            nas.push_back( left[ind1] );
            ind1 ++;
            continue;
        }


        std::vector< bool > curr = makeQ( left[ ind1 ], right[ ind2 ] );


        cerr << " curr " << endl;
        for( auto j : curr ) cerr << j <<" ";
        cerr << endl << endl;
        cerr << out( kk ) <<
        out( curr[kk] ) << endl;


        // left < right
        if( curr[kk] ){
            nas.push_back( left[ind1++] );
        }else{
            nas.push_back( right[ind2++] );
        }
    }
    cerr << "nas" << endl;
    for( auto j : nas ) cerr << j << " ";
    cerr << endl;

    v = nas;
}

std::vector<std::vector<int>> pointSort(int n, int k){
    std::vector<std::vector<int>> nas;
    nas.resize( n );
    for( int i=0 ; i < n ; i++ ) nas[i].resize( k );
    cerr << out( n ) << out( k ) << endl;
    for( int i=0 ; i < k ; i++ ){
        std::vector< int > ind( n );
        std::iota( ind.begin(), ind.end(), 0 );
        sol( i, 0, n-1, ind );

        for( auto j : ind ) cerr << j << " ";
        cerr << endl;

        for( int j=0 ; j < n ; j++ ){
            nas[ind[j]][i] = j;
        }
    }

    cerr << "!!" << endl;
    for( int i=0 ; i < n ; i++ ){
        for( int j=0 ; j < k ; j++ ) cerr << nas[i][j] << " ";
        cerr << endl;
    }
    cerr << endl << endl;

    return nas;
}





