#include<iostream>
#include <algorithm>
#include <vector>
#include <map>
#include "pointsort.h"
using namespace std;
const int MAXN = 1e4+7;
const int MAXK = 8;
vector<int> coord[MAXN];
vector<vector<int>> ans;
int o;
vector<bool> sr;
int podredba[MAXK][MAXN]; /// za vseki koordinat kak sa podredeni tochkite (po default 1,2,3,4... i gi sortiram i posle im davam stoinosti v coord)
int arr1[MAXN];
map<pair<int,int>,vector<bool>> mapche;
void merge_sort(int l,int r){
    if(l==r) return;
    int m = (l+r)/2;
    merge_sort(l,m);
    merge_sort(m+1,r);

    /// merge
    //cerr<<"merge-vam "<<l<<" do "<<r<<"\n";
    int i=l,j=m+1,ind=l;
    for(i=l;i<=m;i++){
        arr1[i]=podredba[o][i];
        //cerr<<"arr1["<<i<<"] e = "<<arr1[i]<<" ";
    }
    for(j=m+1;j<=r;j++){
        arr1[j]=podredba[o][j];
        //cerr<<"arr1["<<j<<"] e = "<<arr1[j]<<" ";
    }//cerr<<"\n";
    i=l;
    j=m+1;
    while(ind<=r){
       if(i>m) {
            //cout<<"podredba1["<<o<<"]["<<ind<<"] = "<<arr1[j]<<"\n";
            podredba[o][ind]=arr1[j];
            j++;
            ind++;
       }else if(j>r){
            //cout<<"podredba2["<<o<<"]["<<ind<<"] = "<<arr1[i]<<"\n";
            podredba[o][ind]=arr1[i];
            i++;
            ind++;
       }else{
           if(mapche.find({arr1[i],arr1[j]})!=mapche.end()) sr = mapche[{arr1[i],arr1[j]}];
           else sr=compare(arr1[i],arr1[j]);
           mapche[{arr1[i],arr1[j]}]=sr;
           if(sr[o]){
                podredba[o][ind]=arr1[i];
                //cout<<"podredba3["<<o<<"]["<<ind<<"] = "<<arr1[i]<<"\n";
                i++;
           }else{
                podredba[o][ind]=arr1[j];
                //cout<<"podredba4["<<o<<"]["<<ind<<"] = "<<arr1[j]<<"\n";
                j++;
           }
           ind++;
       }
    }
}
vector<vector<int>> pointSort(int n, int k){
    for(o=0;o<k;o++){ /// koordinata
        for(int i=0;i<n;i++){
            podredba[o][i]=i;
        }
        merge_sort(0,n-1);
        for(int i=0;i<n;i++){
            coord[podredba[o][i]].push_back(i);
        }
    }
    ans.clear();
    for(int i=0;i<n;i++){
        /*for(auto p:coord[i]){
            cout<<p<<" ";
        }cout<<"\n";*/
        ans.push_back(coord[i]);
        coord[i].clear();
    }
    return ans;
}
