#include<iostream>
#include "pointsort.h"
using namespace std;
vector<vector<int> > v;
int tree[40005][6],numiz;
void build(int node,int l,int r,int iz)
{
    if(l==r)
    {
        for(int i=0;i<numiz;i++)
            tree[node][i]=l;

        return;
    }
    int mid=(l+r)/2;

    if(iz!=0 && ((l==mid) && (mid+1==r)))
      return;

    build(2*node,l,mid,iz);
    build(2*node+1,mid+1,r,iz);

    vector<bool> b=compare(tree[2*node][iz]-1,tree[2*node+1][iz]-1);
    if(b[iz]==1)
        tree[node][iz]=tree[2*node+1][iz];
    else
        tree[node][iz]=tree[2*node][iz];

    if(iz==0)
    {
        if((l==mid) && (mid+1==r))
         {
             for(int t=1;t<numiz;t++)
             {
                 if(b[t]==1)
                    tree[node][t]=tree[2*node+1][0];
                 else
                    tree[node][t]=tree[2*node][0];
             }

         }
    }
}
void update(int node,int l,int r,int p,int iz)
{
    if(l>p || r<p) return;
    if(l==r)
    {
        tree[node][iz]=-1;
        return;
    }

    int mid=(l+r)/2;

    update(2*node,l,mid,p,iz);
    update(2*node+1,mid+1,r,p,iz);

    if(tree[2*node+1][iz]==-1)
        tree[node][iz]=tree[2*node][iz];
    else if(tree[2*node][iz]==-1)
        tree[node][iz]=tree[2*node+1][iz];

    else{
        vector<bool> b=compare(tree[2*node][iz]-1,tree[2*node+1][iz]-1);

    if(b[iz]==1)
        tree[node][iz]=tree[2*node+1][iz];
    else
        tree[node][iz]=tree[2*node][iz];
    }
}
vector<std::vector<int>> pointSort(int n, int k)
{
    int pos;
    numiz=k;

    v.clear();
    v.resize(n);

    for(int i=0;i<n;i++)
        v[i].resize(k,0);

    vector<bool> b;

    for(int i=0;i<k;i++)
    {
        build(1,1,n,i);
        for(int j=n-1;j>=0;j--)
        {
            pos=tree[1][i];
            update(1,1,n,tree[1][i],i);
            v[pos-1][i]=j;
        }
    }
    /*for(int i=0;i<n;i++)
    {
        for(int j=0;j<k;j++)
            cout<<v[i][j]<<" ";
        cout<<endl;
    }


    for(int j=i+1;j<n;j++)
        {
            b=compare(i,j);
            for(int s=0;s<b.size();s++)
            {
                if(b[s]==0)
                    v[i][s]++;

                else
                    v[j][s]++;
            }
        }*/
    return v;
}

