#include<iostream>
#include<algorithm>
#include<map>
#include "pointsort.h"
using namespace std;
const int maxn=1e4+10;
map<pair<int,int>,vector<bool>> mp;
vector<int> merge_sort(int l, int r, int p)
{
    if(l==r)return {l};
    int mid=(l+r)>>1;
    vector<int> a=merge_sort(l,mid,p);
    vector<int> b= merge_sort(mid+1,r,p);
    vector<int> tmp;
    tmp.reserve(a.size()+b.size());
    int ptr1=0,ptr2=0;
    while(ptr1<a.size()&&ptr2<b.size())
    {
        vector<bool> ret;
        if(!mp[{a[ptr1],b[ptr2]}].empty())ret=mp[{a[ptr1],b[ptr2]}];
        else{
           ret = compare(a[ptr1],b[ptr2]);
           mp[{a[ptr1],b[ptr2]}]=ret;
        }
         

        if(ret[p]==1)tmp.push_back(a[ptr1++]);
        else tmp.push_back(b[ptr2++]);
    }
    while(ptr1<a.size())
    {
        tmp.push_back(a[ptr1++]);
    }
    while(ptr2<b.size())
    {
        tmp.push_back(b[ptr2++]);
    }
    return tmp;
}
vector<std::vector<int>> pointSort(int n, int k)
{
    mp.clear();
    vector<vector<int>> ans;
    ans.resize(n);
    for(int i=0; i<n; i++)
    {
        ans[i].resize(k);
    }
    for(int i=0;i<k;i++)
    {
        vector<int> sorted = merge_sort(0,n-1,i);
        for(int j=0;j<sorted.size();j++)
        {
            ans[sorted[j]][i]=j;
        }
    }
    return ans;
}
