#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXE = 1e7+50;

int64_t ans[MAXE];

struct Edge
{
    int a, b;
    int64_t total;

    Edge(){}
    Edge(int a, int b, int64_t total)
        :a(a), b(b), total(total){}
};

vector <Edge> edges;
map <pair <int, int>, int> mp;
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int N, M, K, i, j, k;
    cin >> N >> M;
    for (i = 0; i < M; i++)
    {
        cin >> K;
        vector <int> mushrooms(K);
        for (j = 0; j < K; j++)
        {
            cin >> mushrooms[j];
        }

        for (j = 0; j < K; j++)
        {
            for (k = j+1; k < K; k++)
            {
                edges.emplace_back(mushrooms[j], mushrooms[k], i+1);
                edges.emplace_back(mushrooms[k], mushrooms[j], i+1);
            }
        }
    }

    pair <int, int> p;
    k = 0;
    for (Edge &e: edges)
    {
        if (e.a > e.b)
            swap(e.a, e.b);

        p.first = e.a;
        p.second = e.b;

        if (mp.find(p) == mp.end())
            mp[p] = k++;

        ans[mp[p]] += e.total;
    }

    int Q, L, R;
    cin >> Q;
    for (i = 0; i < Q; i++)
    {
        cin >> L >> R;

        p = {L, R};
        if (mp.find(p) == mp.end())
        {
            cout << 0 << endl;
            continue;
        }
        cout << ans[mp[{L, R}]]/2 << endl;
    }

    return 0;
}

/*
6 3
3 1 2 3
2 5 6
3 2 5 6
4
1 2
2 5
3 6
5 6
*/
