#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN = 1e5+50;

vector <int> graph[MAXN];
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int N, M;
    cin >> N >> M;
    for (int i = 0; i < M; i++)
    {
        int K;
        cin >> K;

        for (int j = 0; j < K; j++)
        {
            int mushroom;
            cin >> mushroom;

            graph[mushroom].push_back(i+N+1);
        }
    }

    for (int i = 1; i <= N; i++)
    {
        sort (graph[i].begin(), graph[i].end());
    }

    int Q;
    cin >> Q;
    for (int i = 0; i < Q; i++)
    {
        int L, R;
        cin >> L >> R;

        int ans = 0, a = 0, b = 0;

        while (a < graph[L].size() && b < graph[R].size())
        {
            if (graph[L][a] == graph[R][b])
            {
                ans += (graph[L][a]-N);
                a++;
                b++;
            }

            if (graph[L][a] < graph[R][b])
                a++;

            if (graph[L][a] > graph[R][b])
                b++;
        }

        cout << ans << endl;
    }

    return 0;
}

/*
6 3
3 1 2 3
2 5 6
3 2 5 6
4
1 2
2 5
3 6
5 6
*/
