#include <bits/stdc++.h>
#include "candies.h"

#ifdef __LOCAL__
    #include "Lgrader.cpp"
#endif // __LOCAL__

#define endl '\n'

using namespace std;

vector <int> children, machines;
void init(std::vector<int> kids, const std::vector<int> candies)
{
    children = kids;
    machines = candies;
}

bool check(int l, int r, int k, vector <int> c, vector <int> m)
{
    c[r] -= k;
    m[r] -= k;

    int curr;
    for (curr = r; curr > l; curr--)
    {
        if (curr != r)
        {
            c[curr] -= m[curr];
            m[curr] = min(m[curr], 0);
        }
        m[curr-1] -= c[curr];
        c[curr] = 0;

        if (m[curr] < 0)
            return false;

        if (curr == r)
            continue;
    }

    c[curr] -= m[curr];
    m[curr] = min(m[curr], 0);

    m[r] -= c[curr];
    if (m[r] < 0)
        return false;

    return true;
}
bool isValid(int l, int r)
{
    for (int i = 0; i <= machines[r]; i++)
    {
        if (check(l, r, i, children, machines))
            return true;
    }
    return false;

}
void update(int l, int r, int x, int y)
{
    for (int i = l; i <= r; i++)
    {
        children[i] = x;
        machines[i] = y;
    }
}

/*
5
2 0 9 4 1
0 5 4 6 7
7
2 4 4 8 1
1 0 1
2 3 3 4 9
2 1 2 2 2
1 3 4
1 2 2
1 2 4

3
1 0 3
0 0 4
1
1 0 2
*/
