#include "pointsort.h"
#include <algorithm>
#include <iostream>
#include <random>
#pragma GCC optimize("O3")
#define pb push_back

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

const int maxn=1e5+2;
const int mod=1e9+7;

bool used[6][maxn];

vector<vector<int>> ans;

vector<std::vector<int>> pointSort(int n, int k){

    for(int i=0; i<=k; i++){
        for(int j=0; j<=n; j++) used[i][j]=false;
    }
    ans.clear();

    vector<int> zeroes;

    for(int i=0; i<k; i++){
        zeroes.pb(0);
    }

    for(int i=0; i<n; i++){
        ans.pb(zeroes);
    }

    for(int curr_coord=0; curr_coord<k; curr_coord++){

        for(int i=n-1; i>=0; i--){
            if(i==0){
                for(int j=0; j<n; j++){
                    if(!used[curr_coord][j]){
                        ans[j][curr_coord]=0;
                        break;
                    }
                }
            }else{
                int cand=0;
                while(used[curr_coord][cand]) cand++;

                for(int j=0; j<n; j++){
                    if(used[curr_coord][j] or j==cand) continue;

                    vector<bool> curr=compare(cand, j);
                    if(curr[curr_coord]){
                        cand=j;
                    }

                }
                used[curr_coord][cand]=true;
                ans[cand][curr_coord]=i;
            }
        }
    }

   /* for(int i=0; i<n; i++){
        cout<<"( ";
        for(int j=0; j<k; j++){
            cout<<ans[i][j]<<", ";
        }
        cout<<")"<<endl;
    }
    */
    return ans;
}