#include "pointsort.h"

using namespace std;
int K;

void mergesort(int l, int r, vector<vector<int>>&v){
    if(l == r || l > r)
        return;


    int mid = (l+r)/2;
    mergesort(l,mid,v);
    mergesort(mid+1,r,v);

    for(int i=l;i<=mid;i++)
    for(int j=mid+1;j<=r;j++){
        auto vb = compare(i,j);
        for(int d=0; d<K;d++){
            if(!vb[d])
                v[i][d]++;
            else
                v[j][d]++;
        }
    }
}

vector<vector<int>> pointSort(int n, int k){
    vector<vector<int>> p(n,vector<int>(k));
    mergesort(0,n,p);
    for(int i=0; i<n;i++)
        for(int j=0; j<k;j++)
            p[i][k] /= k;
    return p;
}
