#include "pointsort.h"

using namespace std;
int K;

void mergesort(int l, int r, vector<vector<int>>&v){
    if(l == r || l > r)
        return;


    int mid = (l+r)/2;
    mergesort(l,mid,v);
    mergesort(mid+1,r,v);

    for(int i=l;i<=mid;i++)
    for(int j=mid+1;j<=r;j++){
        auto vb = compare(i,j);
        for(int d=0; d<K;d++){
            if(!vb[d]){
                v[i][d]++;
                v[j][d]--;
            }
            else{
                v[j][d]++;
                v[i][d]--;
            }
        }
    }
}

vector<vector<int>> pointSort(int n, int k){
    vector<vector<int>> p(n,vector<int>(k));
    mergesort(0,n-1,p);
    return p;
}
