#define _GLIBCXX_FILESYSTEM
#include <iostream>
#include <vector>
#include "candies.h"
using namespace std;
vector<int> kids_, candies_;
void init(std::vector<int> kids, const std::vector<int> candies){
    kids_ = kids;
    candies_ = candies;
}

bool isValid(int l, int r){
    bool valid = false;
    for(int i = l; i <= r; i++){
        if(i == 1){
            if(kids_[i] <= candies[i] + candies[r]){
                valid = true;
            } else {
                return false;
            }
        } else {
            if(kids_[i] <= candies[i] + candies[i-1]){
                valid = true;
            } else {
                return false;
            }
        }
    }
    return valid;
}

void update(int l, int r, int x, int y){
    for(int i = l; i <= r; i++){
        kids_[i] = x;
        candies_[i] = y;
    }
    init(kids_, candies_);
}
