#include "candies.h"
#include<bits/stdc++.h>
using namespace std;

struct node {
    long long big;
    long long sm;
    long long pr;
    long long su;
    long long pr2;
    long long su2;
    long long sum;
};

vector<long long> haha(200001);
vector<long long> bruh(200001);
vector<node> seg(800001);

int n;

node troll(node a, node b) {
    node ans;
    ans.sum = a.sum+b.sum;
    ans.pr = min(a.pr,a.sum+b.pr);
    ans.su = max(b.su,a.su+b.sum);
    ans.pr2 = max(a.pr2,a.sum+b.pr2);
    ans.su2 = min(b.su2,b.sum+a.su2);
    ans.big = max(a.big,b.big);
    ans.big = max(ans.big,a.su+b.pr2);
    ans.sm = min(ans.sm,a.su2+b.pr);
    return ans;
}

void build(int l, int r, int x) {
    if(l == r) {
        node a;
        a.sum = bruh[l]-haha[l];
        a.pr = min(0LL,a.sum);
        a.su = max(0LL,a.sum);
        a.big = -haha[l];
        a.sm = bruh[l];
        a.pr2 = -haha[l];
        a.su2 = bruh[l];
        seg[x] = a;
        return;
    }
    int mid = (l+r)/2;
    build(l,mid,x*2);
    build(mid+1,r,x*2+1);
    seg[x] = troll(seg[x*2],seg[x*2+1]);
}

void upd(int l, int r, int x, int p) {
    if(l == r) {
        node a;
        a.sum = bruh[l]-haha[l];
        a.pr = min(0LL,a.sum);
        a.su = max(0LL,a.sum);
        a.big = -haha[l];
        a.sm = bruh[l];
        a.pr2 = -haha[l];
        a.su2 = bruh[l];
        seg[x] = a;
        return;
    }
    int mid = (l+r)/2;
    if(p <= mid) {
        upd(l,mid,x*2,p);
    }
    else {
        upd(mid+1,r,x*2+1,p);
    }
    seg[x] = troll(seg[x*2],seg[x*2+1]);
}

node dude(int l, int r, int ql, int qr, int x) {
    if(l == ql && r == qr) {
        return seg[x];
    }
    int mid = (l+r)/2;
    if(qr <= mid) {
        return dude(l,mid,ql,qr,x*2);
    }
    else if(ql > mid) {
        return dude(mid+1,r,ql,qr,x*2+1);
    }
    else {
        node a = dude(l,mid,ql,mid,x*2);
        node b = dude(mid+1,r,mid+1,qr,x*2+1);
        return troll(a,b);
    }
}

bool isValid(int l, int r) {
    node a = dude(0,n-1,l,r,1);
    if(a.sum < 0 || a.sm < 0 || a.big > a.sum) {
        return false;
    }
    else {
        return true;
    }
}

void update(int l, int r, int x, int y) {
    for(int i = l; i <= r; i++) {
        haha[i] = x;
        bruh[i] = y;
        upd(0,n-1,1,i);
    }
}

void init(std::vector<int> kids, const std::vector<int> candies) {
    n = kids.size();
    for(int i = 0; i < n; i++) {
        haha[i] = kids[i];
        bruh[i] = candies[i];
    }
    build(0,n-1,1);
}
