# include <iostream>
# include <bitset>
# include <vector>
using namespace std;

const int MAX=1e5+1,bl_sz=4000,S=bl_sz+1;

int n,m,q;
bitset<S> b[MAX];
vector<int> a[MAX];
pair<int,int> z[MAX];
long long out[MAX];

int getL(int x) {return (x-1)*bl_sz+1;}
int getR(int x) {return min(m,bl_sz*x);}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    cin>>n>>m;
    for(int i=1;i<=m;i++)
    {
        int k;
        cin>>k;
        while(k--)
        {
            int x;
            cin>>x;
            a[i].push_back(x);
        }
    }

    cin>>q;
    for(int i=1;i<=q;i++)
    {
        int u,v;
        cin>>u>>v;
        z[i]={u,v};
    }

    bitset<S> bs;
    for(int tt=1;tt<=(m+bl_sz-1)/bl_sz;tt++)
    {
        int add=(tt-1)*bl_sz,l=getL(tt),r=getR(tt);
        for(int i=1;i<=n;i++) b[i]&=0;

        for(int i=l;i<=r;i++)
        {
            for(int x: a[i])
            {
                b[x][i-add]=1;
            }
        }

        for(int i=1;i<=q;i++)
        {
            int u=z[i].first,v=z[i].second;

            bs=(b[u]&b[v]);
            int id=bs._Find_next(0);
            while(id!=S)
            {
                out[i]+=id+add;
                id=bs._Find_next(id);
            }

        }
    }

    for(int i=1;i<=q;i++) cout<<out[i]<<"\n";

    return 0;
}


