# include <iostream>
# include <vector>
# include <algorithm>
# include <random>
# include <map>
using namespace std;
# include "pointsort.h"
# include "Lgrader.cpp"

const int MAXD=1e6+11;
const int MAX=1e4+11;

mt19937 rng(69);

int curr_k,ct=0;
map<pair<short,short>,int> vis;
vector<bool> Data[MAXD];

bool cmp(int x, int y)
{
    if(x==y) return false;
    if(vis.find({x,y})!=vis.end())
    {
        int id=vis[{x,y}];
        return Data[id][curr_k];
    }
    else if(vis.find({y,x})!=vis.end())
    {
        int id=vis[{y,x}];
        return !Data[id][curr_k];
    }
    else
    {
        ct++;
        vector<bool> resp=compare(x,y);
        vis[{x,y}]=ct;
        Data[ct]=resp;
        return Data[ct][curr_k];
    }
}

int a[MAX];
int b[MAX];

void merge_sort(int l, int r)
{
    if(l==r)
    {
        a[l]=l;
        return ;
    }

    int mid=(l+r)/2;
    merge_sort(l,mid);
    merge_sort(mid+1,r);

    int pA=l,pB=mid+1;
    for(int i=l;i<=r;i++)
    {
        if(pB==r+1 or (pA!=mid+1 and cmp(a[pA],a[pB])))
        {
            b[i]=a[pA];
            pA++;
        }
        else
        {
            b[i]=a[pB];
            pB++;
        }
    }

    for(int i=l;i<=r;i++) a[i]=b[i];
}

vector<vector<int>> pointSort(int n, int k)
{
    ct=0;
    vis.clear();

    vector<vector<int>> res;
    res.resize(n);
    for(int j=0;j<n;j++) res[j].resize(k);

    for(int j=0;j<k;j++)
    {
        for(int i=0;i<n;i++) a[i]=i;
        curr_k=j;
        if(j%2==1) merge_sort(0,n-1);
        else sort(a,a+n,cmp);

        for(int i=0;i<n;i++) res[a[i]][j]=i;
    }

    return res;
}

/*
1
10000 2 1
*/
