# include <iostream>
# include <vector>
# include <algorithm>
# include <random>
# include <map>
using namespace std;
# include "pointsort.h"
//# include "Lgrader.cpp"

const int MAXD=5e6+11;
const int MAX=1e4+11;

int curr_k,ct=0;
map<pair<int,int>,int> vis;
vector<bool> Data[MAXD];

bool cmp(int x, int y)
{
    if(x==y) return false;
    if(vis.find({x,y})!=vis.end())
    {
        int id=vis[{x,y}];
        return Data[id][curr_k];
    }
    else if(vis.find({y,x})!=vis.end())
    {
        int id=vis[{y,x}];
        return !Data[id][curr_k];
    }
    else
    {
        ct++;
        vector<bool> resp=compare(x,y);
        vis[{x,y}]=ct;
        Data[ct]=resp;
        return Data[ct][curr_k];
    }
}

vector<vector<int>> pointSort(int n, int k)
{
    ct=0;
    vis.clear();

    vector<vector<int>> res;
    res.resize(n);
    for(int j=0;j<n;j++) res[j].resize(k);

    for(int j=0;j<k;j++)
    {
        curr_k=j;
        vector<int> v;
        for(int i=0;i<n;i++) v.push_back(i);
        sort(v.begin(),v.end(),cmp);

        for(int i=0;i<n;i++) res[v[i]][j]=i;
    }

    return res;
}

/*
1
10000 2 1
*/
