# define _GLIBCXX_FILESYSTEM
# include <bits/stdc++.h>
# define ll long long
using namespace std;

const int MAXN = 1e5 + 1;
const int MAXM = 1e5 + 1;
map<pair<int, int>, int> dp;
map<pair<int, int>, bool> Query;
int N, M, Q;
vector<pair<int, int>> Queries;
vector<int> A[MAXM];

void Upgrade_Speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N >> M;

    for(int i = 0; i < M; i++)
    {
        int Size; cin >> Size;

        for(int j = 0; j < Size; j++)
        {
            int Value; cin >> Value;
            A[i].push_back(Value);
        }
    }
}

void Solve()
{
    cin >> Q;

    for(int i = 0; i < Q; i++)
    {
        int X, Y; cin >> X >> Y;
        Queries.push_back({X, Y});
        Query[{X, Y}] = true;
    }

    for(int i = 0; i < M; i++)
    {
        for(int j = 0; j < (int)A[i].size(); j++)
        {
            for(auto& U : A[i])
            {
                if(!Query[{A[i][j], U}]) continue;
                dp[{A[i][j], U}] += i + 1;
            }
        }
    }

    for(auto& [X, Y] : Queries)
    {
        cout << dp[{X, Y}] << '\n';
    }
}

int main()
{
    Upgrade_Speed();
    Read();
    Solve();
    return 0;
}
