# define _GLIBCXX_FILESYSTEM
# include "candies.h"
# include <bits/stdc++.h>
# define ll long long
using namespace std;

const int MAXN = 2 * 1e5 + 1;
int N;
ll A[MAXN];
ll B[MAXN];

void init(vector<int> Kids, vector<int> Candies)
{
    N = (int)Kids.size();
    for(int i = 0; i < N; i++) A[i] = Kids[i];
    for(int i = 0; i < N; i++) B[i] = Candies[i];
}


bool isValid(int l, int r)
{
    vector<int> CopyB(N + 1);
    vector<int> CopyA(N + 1);
    int Size = (r - l + 1);

    for(int i = 0; i < Size; i++)
    {
        CopyA[i] = A[i + l];
        CopyB[i] = B[i + l];
    }

    int Counter = 0;

    ///cout << " Query Start " << '\n';

    for(int Cycle = 0; Cycle < N * N * N * N; Cycle++)
    {
        Counter = 0;
        ///cout << '\n';
        ///cout << " Start " << '\n';

        for(int i = 0; i < Size; i++)
        {
            ///cout << CopyA[i] << " : " << CopyB[i] << '\n';
            if(CopyA[i] > CopyB[i])
            {
                Counter++;
                CopyB[(i - 1 + Size) % Size] -= (CopyA[i] - CopyB[i]);
                CopyB[i] = CopyA[i];
            }
        }

        if(Counter == 0) break;
    }

    if(Counter == 0) return true;
    return false;
}

void update(int l, int r, int x, int y)
{
    for(int i = l; i <= r; i++)
    {
        A[i] = x;
        B[i] = y;
    }
}

