# define _GLIBCXX_FILESYSTEM
# include "candies.h"
# include <bits/stdc++.h>
# define ll long long
using namespace std;

const int MAXN = 2 * 1e5 + 1;
int N;
ll A[MAXN];
ll B[MAXN];

void init(vector<int> kids, vector<int> candies)
{
    N = (int)kids.size();

    for(int i = 0; i < N; i++)
    {
        A[i] = kids[i];
    }
    for(int i = 0; i < N; i++) B[i] = candies[i];
}

bool isValid(int l, int r)
{
    ll Current = 0;
    bool Flag = false;

    for(int i = 0; i < N; i++)
    {
        Current -= A[i];
        Current += B[i];

        if(A[i] > B[i] + B[(i + N - 1) % N])
        {
            Flag = true;
            break;
        }
    }

    if(Flag || Current < 0) return false;
    return true;
}

void update(int l, int r, int x, int y)
{
    for(int i = l; i <= r; i++)
    {
        A[i] = x;
        B[i] = y;
    }
}

