# define _GLIBCXX_FILESYSTEM
# include <bits/stdc++.h>
# define ll long long
# include "candies.h"
using namespace std;

const int MAXN = 1e5  + 1;
int N, Q;
ll A[MAXN];
ll B[MAXN];

void init(vector<int> Kids, vector<int> Candies)
{
    N = (int)Kids.size();
    for(int i = 0; i < N; i++) A[i] = Kids[i];
    for(int i = 0; i < N; i++) B[i] = Candies[i];
}

bool isValid(int l, int r)
{
    int SumL = 0, SumR = 0;

    for(int i = l; i <= r; i++)
    {
        SumL += A[i];
        SumR += B[i];
    }

    if(SumL <= SumR)
    {
        return true;
    }

    return false;
}

void update(int l, int r, int x, int y)
{
    for(int i = l; i <= r; i++)
    {
        A[i] = x;
        B[i] = y;
    }
}
