#include <bits/stdc++.h>
#define endl "\n"
using namespace std;

const int MAXN = 1e5+5;
const int MAXM = 5e4+5;
const int K = 320;

int n,m,q;
vector<int>k[MAXM];
vector<int>g[MAXN];

struct qu
{
    int a,b,num;
};
vector<qu>sp;

int ind,no[MAXN];

int used[K][MAXM];
long long mat[K][K];

void pre()
{
    for(int i = 1; i <= n; i++) sort(g[i].begin(),g[i].end());

    for(int i = 1; i <= n; i++)
    {
        if(g[i].size() >= K) no[i] = ++ind;
    }
    for(int i = 1; i <= m; i++)
    {
        for(int x : k[i]) if(g[x].size() >= K) used[no[x]][i] = 1;
    }

    for(int i = 1; i <= m; i++)
    {
        vector<int>v;
        for(int x : k[i]) if(g[x].size() >= K) v.push_back(no[x]);

        for(int x = 0; x < v.size(); x++)
        {
            for(int y = x+1; y < v.size(); y++)
            {
                mat[v[x]][v[y]] += i;
                mat[v[y]][v[x]] += i;
            }
        }
    }
}



long long query(int a, int b)
{
    if(g[a].size() > g[b].size()) swap(a,b);

    if(no[b])
    {
        long long res = 0;
        for(int kosh : g[a])
        {
            if(used[no[b]][kosh]) res += kosh;
        }
        return res;
    }
    else
    {
        int p = 0;
        long long res = 0;
        for(int kosh : g[a])
        {
            while(p < g[b].size() && g[b][p] < kosh) p++;
            if(p == g[b].size()) break;

            if(g[b][p] == kosh) res += kosh;

        }
        return res;
    }
}

long long mazna(int a, int b)
{
    return mat[no[a]][no[b]];
}

void read()
{
    cin >> n >> m;
    int sz,x;
    for(int i = 1; i <= m; i++)
    {
        cin >> sz;
        k[i].resize(sz);
        for(int j = 0; j < sz; j++)
        {
            cin >> x;
            k[i][j] = x;
            g[x].push_back(i);
        }
        sort(k[i].begin(),k[i].end());
    }
    pre();

    cin >> q;
    int a,b;
    for(int i = 1; i <= q; i++)
    {
        cin >> a >> b;
        if((int)g[a].size() < K || (int)g[b].size() < K) cout << query(a,b) << endl;
        else cout << mazna(a,b) << endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    return 0;
}
