#include "candies.h"
#include <iostream>

const int MAXN = 2e5+5;

int n, a[MAXN],b[MAXN];

bool check(int k, int l, int r)
{
    int ans = k;
    for(int i = l; i <= r; i++)
    {
        ans = std::min(ans,a[i]) - a[i] + b[i];
        if(ans < 0) return false;///ai ostava gladno
    }
    return true;
}

bool check_2(int k, int l, int r)
{
    int ans = k;
    for(int i = l; i <= r; i++)
    {
        ans = std::min(ans,a[i]) - a[i] + b[i];
        if(i == r) ans -= k;
        if(ans < 0) return false;///ai ostava gladno
    }
    return true;
}

int bin_s(int l, int r)
{
    int L = 0, R = std::min(b[r],a[l]);
    int mid;
    while(L <= R)
    {
        mid = (L+R)/2;
        if(check(mid,l,r)) R = mid-1;
        else L = mid+1;
    }
    return L;
}

bool isValid(int l, int r)
{
    return check_2(bin_s(l,r),l,r);
}


void update(int l, int r, int x, int y)
{
    for(int i = l; i <= r; i++)
    {
        a[i] = x;
        b[i] = y;
    }
}

/*void make_tree(int v, int l, int r)
{
    if(l == r)
    {
        tree[v] = bin_s(l,r);
        return;
    }
    int mid = (l+r)/2;
    make_tree(v*2+0,l,mid+0);
    make_tree(v*2+1,mid+1,r);
    tree[v] = bin_s(l,r);
}*/

void init(std::vector<int> kids, const std::vector<int>candies)
{
    n = kids.size();
    for(int i = 0; i < n; i++) a[i] = kids[i];
    for(int i = 0; i < n; i++) b[i] = candies[i];

    //make_tree(1,0,n-1);
}
