#include "candies.h"
#include <bits/stdc++.h>

using namespace std;

const int MAXN = 2e5+5;

long long n, a[MAXN],b[MAXN];

bool check(int k, int l, int r)
{
    long long ans = k;
    for(int i = l; i <= r; i++)
    {
        long long ost = min(ans-a[i],(long long) 0);
        ans = ost + b[i];
        if(ans < 0) return false;///ai ostava gladno
    }
    return true;
}

bool check_2(int k, int l, int r)
{
    long long ans = k;
    for(int i = l; i <= r; i++)
    {
        long long ost = min(ans-a[i],(long long) 0);
        ans = ost + b[i];
        if(i == r) ans -= k;
        if(ans < 0) return false;///ai ostava gladno
    }
    return true;
}

bool isValid(int l, int r)
{

    int L = 0, R = 1e9;
    int mid;
    while(L <= R)
    {
        mid = (L+R)/2;
        if(check(mid,l,r)) R = mid-1;
        else L = mid+1;
    }
    return check_2(L,l,r);
}


void update(int l, int r, int x, int y)
{
    for(int i = l; i <= r; i++)
    {
        a[i] = x;
        b[i] = y;
    }
}


void init(std::vector<int> kids, const std::vector<int>candies)
{
    n = kids.size();
    for(int i = 0; i < n; i++) a[i] = kids[i];
    for(int i = 0; i < n; i++) b[i] = candies[i];
}
