#define _GLIBCXX_FILESYSTEM
#include <bits/stdc++.h>

using namespace std;

const int maxn = 100005;
const int BIG_SIZE = 500;

int n, m, q;
vector<int> a[maxn];
unordered_set<int> where[maxn];
int ans[1005][1005];
bitset<105> bs[maxn];
vector<int> basekts[maxn];
vector<int> bigInBasket[maxn];

int cntBig = 0;
vector<int> big;
int bigIndex[maxn];
int bigToReal[maxn];

long long singleAns[maxn];
long long bigAns[1005][1005];

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> m;

    for (int i = 1; i <= m; ++i)
    {
        int k;
        cin >> k;

        for (int j = 0; j < k; ++j)
        {
            int x;
            cin >> x;
            basekts[i].push_back(x);
            a[x].push_back(i);
            where[x].insert(i);
            singleAns[x] += i;
        }
    }

    /*if (m <= 100)
    {
        for (int i = 1; i <= n; ++i)
        {
            for (auto j : a[i])
            {
                bs[i][j] = 1;
            }
        }

        cin >> q;

        bitset<105> common;
        int ans = 0;

        for (int i = 1; i <= q; ++i)
        {
            int x, y;
            cin >> x >> y;

            common = bs[x] & bs[y];
            ans = 0;

            for (int j = 1; j <= m; ++j)
            {
                if (common[j] == 1)
                {
                    ans += j;
                }
            }

            cout << ans << "\n";
        }

        return 0;
    }

    if (n <= 1000)
    {
        for (int i = 1; i <= n; ++i)
        {
            for (int j = i; j <= n; ++j)
            {
                for (auto x : a[i])
                {
                    if (where[j].find(x) != where[j].end())
                    {
                        ans[i][j] += x;
                    }
                }
            }
        }

        cin >> q;

        for (int i = 1; i <= q; ++i)
        {
            int x, y;
            cin >> x >> y;
            if (x > y) swap(x, y);
            cout << ans[x][y] << "\n";
        }

        return 0;
    }*/

    for (int i = 1; i <= n; ++i)
    {
        if (a[i].size() > BIG_SIZE)
        {
            big.push_back(i);
            ++cntBig;
            bigIndex[i] = cntBig;
            bigToReal[cntBig] = i;
        }
    }

    for (int i = 1; i <= m; ++i)
    {
        for (auto j : basekts[i])
        {
            if (a[j].size() > BIG_SIZE)
            {
                bigInBasket[i].push_back(bigIndex[j]);
            }
        }
    }

    int b1, b2;

    for (int i = 1; i <= m; ++i)
    {
        if (bigInBasket[i].size() <= 1) continue;

        for (int j = 0; j < bigInBasket[i].size(); ++j)
        {
            for (int k = j + 1; k < bigInBasket[i].size(); ++k)
            {
                bigAns[min(bigInBasket[i][j], bigInBasket[i][k])][max(bigInBasket[i][j], bigInBasket[i][k])] += i;
            }
        }
    }

    cin >> q;

    for (int i = 1; i <= q; ++i)
    {
        int x, y;
        cin >> x >> y;

        if (x == y)
        {
            cout << singleAns[x] << "\n";
            continue;
        }

        int ans = 0;
        if (a[x].size() > a[y].size()) swap(x, y);

        if (a[x].size() <= BIG_SIZE)
        {
            for (auto curr : a[x])
            {
                if (where[y].find(curr) != where[y].end()) ans += curr;
            }
        }
        else
        {
            x = bigIndex[x];
            y = bigIndex[y];
            ans = bigAns[min(x, y)][max(x, y)];
        }

        cout << ans << "\n";
    }

    return 0;
}
