#define _GLIBCXX_FILESYSTEM
#include <bits/stdc++.h>

using namespace std;

const int maxn = 100005;

int n, m, q;
vector<int> a[maxn];
unordered_set<int> where[maxn];
int ans[1005][1005];
bitset<105> bs[maxn];

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> m;

    for (int i = 1; i <= m; ++i)
    {
        int k;
        cin >> k;

        for (int j = 0; j < k; ++j)
        {
            int x;
            cin >> x;
            a[x].push_back(i);
            where[x].insert(i);
        }
    }
    if (m <= 100)
    {
        for (int i = 1; i <= n; ++i)
        {
            for (auto j : a[i])
            {
                bs[i][j] = 1;
            }
        }

        cin >> q;

        bitset<105> common;
        int ans = 0;

        for (int i = 1; i <= q; ++i)
        {
            int x, y;
            cin >> x >> y;

            common = bs[x] & bs[y];
            ans = 0;

            for (int j = 1; j <= m; ++j)
            {
                if (common[j] == 1)
                {
                    ans += j;
                }
            }

            cout << ans << "\n";
        }

        return 0;
    }

    if (n <= 1000)
    {
        for (int i = 1; i <= n; ++i)
        {
            for (int j = i; j <= n; ++j)
            {
                for (auto x : a[i])
                {
                    if (where[j].find(x) != where[j].end())
                    {
                        ans[i][j] += x;
                    }
                }
            }
        }

        cin >> q;

        for (int i = 1; i <= q; ++i)
        {
            int x, y;
            cin >> x >> y;
            if (x > y) swap(x, y);
            cout << ans[x][y] << "\n";
        }

        return 0;
    }


    cin >> q;

    for (int i = 1; i <= q; ++i)
    {
        int x, y;
        cin >> x >> y;

        int ans = 0;
        if (a[x].size() < a[y].size()) swap(x, y);

        for (auto curr : a[x])
        {
            if (where[y].find(curr) != where[y].end()) ans += curr;
        }

        cout << ans << "\n";
    }

    return 0;
}
