#define _GLIBCXX_FILESYSTEM
#include <bits/stdc++.h>

using namespace std;

const int maxn = 100005;

int n, m, q;
vector<int> a[maxn];
unordered_set<int> where[maxn];

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> m;

    for (int i = 1; i <= m; ++i)
    {
        int k;
        cin >> k;

        for (int j = 0; j < k; ++j)
        {
            int x;
            cin >> x;
            a[x].push_back(i);
            where[x].insert(i);
        }
    }

    cin >> q;

    for (int i = 1; i <= q; ++i)
    {
        int x, y;
        cin >> x >> y;

        int ans = 0;
        if (a[x].size() < a[y].size()) swap(x, y);

        for (auto curr : a[x])
        {
            if (where[y].find(curr) != where[y].end()) ans += curr;
        }

        cout << ans << "\n";
    }

    return 0;
}
