#include "pointsort.h"
#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <random>
#include <math.h>

using namespace std;

const int maxn = 10005;
int best[maxn][5];
int coords[maxn][5];

int DIM;
vector<bool> v;

map<pair<int, int>, vector<bool>> results;

vector<bool> myCompare(int x, int y)
{
    //cout << "here " << x << " " << y << endl;
    if (results.find({x, y}) == results.end() && results.find({y, x}) != results.end())
    {
        vector<bool> curr = results[{y, x}];
        for (int i = 0; i < curr.size(); ++i) curr[i] = 1 - curr[i];
        return results[{x, y}] = curr;
    }
    if (results.find({x, y}) != results.end()) return results[{x, y}];
    return results[{x, y}] = compare(x, y);
}

bool cmp(int x, int y)
{
    v = myCompare(x, y);
    return v[DIM] != 0;
}

vector<vector<int>> pointSort(int n, int k)
{
    results.clear();
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < k; ++j)
        {
            best[i][j] = i;
        }
    }

    for (int i = 0; i < k; ++i)
    {
        //cout << "NEW DIMENSION" << endl;
        vector<int> currOrder;
        currOrder.resize(n);
        for (int j = 0; j < n; ++j)
        {
            currOrder[j] = j;
        }

        DIM = i;
        sort(currOrder.begin(), currOrder.end(), cmp);

        for (int j = 0; j < n; ++j)
        {
            coords[currOrder[j]][i] = j;
        }
    }

    vector<vector<int>> ans;

    for (int i = 0; i < n; ++i)
    {
        ans.push_back({});

        for (int j = 0; j < k; ++j)
        {
            ans.back().push_back(coords[i][j]);
            //cout << ans[i][j] << "";
        }

        //cout << endl;
    }

    return ans;
}
