#include "pointsort.h"
#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <random>
#include <math.h>

using namespace std;

const int maxn = 10005;
int best[maxn][5];
int coords[maxn][5];

int DIM;
vector<bool> v;

bool cmp(int x, int y)
{
    v = compare(x, y);
    return v[DIM] != 0;
}

vector<vector<int>> pointSort(int n, int k)
{
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < k; ++j)
        {
            best[i][j] = i;
        }
    }

    for (int i = 0; i < k; ++i)
    {
        //cout << "NEW DIMENSION" << endl;
        vector<int> currOrder;
        currOrder.resize(n);
        for (int j = 0; j < n; ++j)
        {
            currOrder[j] = j;
        }

        DIM = i;
        sort(currOrder.begin(), currOrder.end(), cmp);

        for (int j = 0; j < n; ++j)
        {
            coords[currOrder[j]][i] = j;
        }
    }

    vector<vector<int>> ans;

    for (int i = 0; i < n; ++i)
    {
        ans.push_back({});

        for (int j = 0; j < k; ++j)
        {
            ans.back().push_back(coords[i][j]);
            //cout << ans[i][j] << "";
        }

        //cout << endl;
    }

    return ans;
}
