#include "candies.h"
#include <iostream>
#include <vector>


using namespace std;

const long long maxn = 200005;

long long a[maxn], b[maxn];
long long n;

void init(vector<int> kids, const vector<int> candies)
{
    n = kids.size();

    for (long long i = 1; i <= n; ++i)
    {
        a[i] = kids[i - 1];
        b[i] = candies[i - 1];
    }
}

bool isValid(int l, int r)
{
    ++l;
    ++r;

    if (l == r)
    {
        return a[l] <= b[l];
    }

    /*for (long long i = l; i <= r; ++i)
    {
        cout << a[i] << " " << b[i] << endl;
    }*/

    long long want = max(0LL, a[l] - b[l]);
    if (want > b[r]) return false;
    long long maxWant = max(b[r], want);

    vector<long long> values;

    for (long long i = want; i <= min(maxWant, want + 20); ++i) values.push_back(i);
    for (long long i = maxWant; i >= max(want, maxWant - 20); --i) values.push_back(i);

    for (int k = 0; k < values.size(); ++k)
    {
        want = values[k];
        long long leftL = min(b[l], b[l] + want - a[l]);
        bool fl = true;

        for (long long i = r; i > l; --i)
        {
            long long curr = b[i] - want;
            long long adjCandies = (i - 1 == l ? leftL : b[i - 1]);
            if (a[i] - curr > adjCandies)
            {
                fl = false;
                break;
            }
            long long need = max(0LL, a[i] - curr);
            want = need;
        }

        if (fl) return true;
    }

    return false;
}

void update(int l, int r, int x, int y)
{
    ++l;
    ++r;

    for (long long i = l; i <= r; ++i)
    {
        a[i] = x;
        b[i] = y;
    }
}
