#include <iostream>
#include <vector>

using namespace std;

const int maxn = 200005;

int a[maxn], b[maxn];
int n;

void init(vector<int> kids, const vector<int> candies)
{
    n = kids.size();

    for (int i = 1; i <= n; ++i)
    {
        a[i] = kids[i - 1];
        b[i] = candies[i - 1];
    }
}

bool isValid(int l, int r)
{
    ++l;
    ++r;

    if (l == r)
    {
        return a[l] <= b[l];
    }

    /*for (int i = l; i <= r; ++i)
    {
        cout << a[i] << " " << b[i] << endl;
    }*/

    int want = max(0, a[l] - b[l]);
    if (want > b[r]) return false;
    int maxWant = max(b[r], want);

    //for (; want <= maxWant; ++want)
    {
        int prvWant = want;
        int leftL = min(b[l], b[l] + want - a[l]);
        bool fl = true;

        for (int i = r; i > l; --i)
        {
            int curr = b[i] - want;
            int adjCandies = (i - 1 == l ? leftL : b[i - 1]);
            if (a[i] - curr > adjCandies)
            {
                fl = false;
                break;
            }
            int need = max(0, a[i] - curr);
            want = need;
        }

        if (fl) return true;
        want = prvWant;
    }

    return false;
}

void update(int l, int r, int x, int y)
{
    ++l;
    ++r;

    for (int i = l; i <= r; ++i)
    {
        a[i] = x;
        b[i] = y;
    }
}
