#include <iostream>
#include <vector>

using namespace std;

const int maxn = 200005;

int a[maxn], b[maxn], curra[maxn], currb[maxn];;
int delta[maxn];
int n;

void init(vector<int> kids, const vector<int> candies)
{
    n = kids.size();

    for (int i = 1; i <= n; ++i)
    {
        a[i] = kids[i - 1];
        b[i] = candies[i - 1];
    }
}

bool isValid(int l, int r)
{
    ++l;
    ++r;

    if (l == r)
    {
        return a[l] <= b[l];
    }

    for (int i = l; i <= r; ++i)
    {
        curra[i] = a[i];
        currb[i] = b[i];
        delta[i] = b[i] - a[i];
    }

    for (int i = r; i > l; --i)
    {
        if (delta[i] < 0)
        {
            delta[i - 1] += delta[i];
            delta[i] = 0;
        }
    }
//cout << "now " << delta[l] << " " << delta[r] << endl;

    return delta[r] + delta[l] >= 0;
}

void update(int l, int r, int x, int y)
{
    ++l;
    ++r;

    for (int i = l; i <= r; ++i)
    {
        a[i] = x;
        b[i] = y;
    }
}
