#include <iostream>
#include <vector>

using namespace std;

const int maxn = 200005;

int a[maxn], b[maxn];
int delta[maxn];
int n;

void init(vector<int> kids, const vector<int> candies)
{
    n = kids.size();

    for (int i = 1; i <= n; ++i)
    {
        a[i] = kids[i - 1];
        b[i] = candies[i - 1];
    }
}

bool isValid(int l, int r)
{
    ++l;
    ++r;

    if (l == r)
    {
        return a[l] <= b[l];
    }

    /*for (int i = l; i <= r; ++i)
    {
        cout << a[i] << " " << b[i] << endl;
    }*/

    for (int i = l; i <= r; ++i)
    {
        delta[i] = b[i] - a[i];
    }

    for (int i = l; i <= r; ++i)
    {
        if (delta[i] < 0)
        {
            delta[i] = -delta[i];
            for (int j = i - 1; j >= l; --j)
            {
                if (delta[j] > 0)
                {
                    if (delta[j] >= delta[i])
                    {
                        delta[i] = 0;
                        delta[j] -= delta[i];
                        break;
                    }
                    else
                    {
                        delta[j] = 0;
                        delta[i] -= delta[j];
                    }
                }
            }

            if (delta[i] == 0) continue;

            for (int j = r; j >= i + 1; --j)
            {
                if (delta[j] > 0)
                {
                    if (delta[j] >= delta[i])
                    {
                        delta[i] = 0;
                        delta[j] -= delta[i];
                        break;
                    }
                    else
                    {
                        delta[j] = 0;
                        delta[i] -= delta[j];
                    }
                }
            }

            if (delta[i] > 0) return false;
        }
    }

    return true;
}

void update(int l, int r, int x, int y)
{
    ++l;
    ++r;

    for (int i = l; i <= r; ++i)
    {
        a[i] = x;
        b[i] = y;
    }
}
