#include <bits/stdc++.h>
#include "pointsort.h"

typedef long long ll;
typedef std::pair <int , int> pii;


std::map <pii , std::vector <bool>> used;
std::map <pii , bool> did;

std::vector <bool> my_query(int x , int y)
{
    if(did[{x , y}] == true)
        return used[{x , y}];

    std::vector <bool> v = compare(x , y);
    used[{x , y}] = v;
    for(int i = 0; i < v.size(); i++)
        v[i] = !v[i];
    used[{y , x}] = v;

    return used[{x , y}];
}

int dim;
std::vector<std::vector <int>> sorted;

bool cmp(int a , int b)
{
    if(a == b)
        return true;
    std::vector <bool> pom = my_query(a , b);
    return pom[dim];
}

std::vector<std::vector<int>> pointSort(int n, int k)
{
    std::vector<std::vector <int>> ans;

    ans.resize(n);

    for(int i = 0; i < n; i++)
        ans[i].resize(k);

    sorted.resize(k);
    for(int i = 0; i < k; i++)
    {
        sorted[i].resize(n);
        dim = i;
        for(int j = 0; j < n; j++)
            sorted[i][j] = j;

        std::sort(sorted[i].begin() , sorted[i].end() , cmp);
        for(int j = 0; j < n; j++)
            ans[sorted[i][j]][i] = j;
    }


    return ans;
}
