#include <bits/stdc++.h>
using namespace std;
#include "candies.h"


vector<int> candiesgl;
vector<int> kidsgl;
void init(std::vector<int> kids, const std::vector<int> candies){
    kidsgl = kids;
    candiesgl = candies;
}
bool isValid(int l, int r){
    int temp = 0;
    for(int i = l + 1; i <= r; i++){
        if(temp + candiesgl[i] < kidsgl[i]) temp = 0;
        temp = candiesgl[i] - kidsgl[i] + temp;
    }
    temp = max(0, candiesgl[r] - kidsgl[r] + temp);
    for(int i = l; i <= r; i++){
        if(temp + candiesgl[i] < kidsgl[i]) return false;
        temp = candiesgl[i] - kidsgl[i] + temp;
    }
    return true;
}
void update(int l, int r, int x, int y){
    for(int i = l; i <= r; i++){
        kidsgl[i] = x;
        candiesgl[i] = y;
    }
}


signed main() {
	std::ios_base::sync_with_stdio(false); std::cin.tie(NULL);
	int64_t n, q;
	std::cin >> n;
	std::vector<int> kids(n), candies(n);
	for (int64_t i = 0; i < n; i ++) { std::cin >> kids[i]; }
	for (int64_t i = 0; i < n; i ++) { std::cin >> candies[i]; }
	init(kids, candies);

	const int64_t mod = 1e9 + 7;
	std::vector<bool> ret;

	std::cin >> q;
	while (q --) {
		int64_t t;
		std::cin >> t;
		if (t == 1) {
			int64_t l, r;
			std::cin >> l >> r;
			const auto ans = isValid(l, r);
			ret.push_back(ans);
		} else if (t == 2) {
			int64_t l, r, x, y;
			std::cin >> l >> r >> x >> y;
			update(l, r, x, y);
		} else {
			assert(false);
		}
	}

	for (int64_t i = 0; i < ret.size(); i ++) {
		std::cout << (bool)ret[i] << std::endl;;
	}
	return 0;
}
