#include <algorithm>
#include <iostream>
#include <vector>

int n, m, q;
std::vector <int> in_which_baskets[100069];

int compute_req(int a, int b) {
    int res = 0;

    std::vector <int> t;
    std::merge(in_which_baskets[a].begin(), in_which_baskets[a].end(), in_which_baskets[b].begin(), in_which_baskets[b].end(), std::back_inserter(t));
    for (int i = 1; i < t.size(); i++) {
        if (t[i] == t[i - 1]) res += t[i];
    }

    return res;
}

int main() {
    std::cin >> n >> m;

    for (int i = 1; i <= m; i++) {
        int k; std::cin >> k;
        for (int j = 0; j < k; j++) {
            int t; std::cin >> t;
            in_which_baskets[t].push_back(i);
        }
    }

    for (int i = 0; i < 100069; i++) {
        sort(in_which_baskets[i].begin(), in_which_baskets[i].end());
    }

    std::cin >> q;

    for (int i = 0; i < q; i++) {
        int a, b; std::cin >> a >> b;
        std::cout << compute_req(a, b) << std::endl;
    }
}
