#include "pointsort.h"
#include <algorithm>
#include <iostream>
#include <utility>
#include <vector>
#include <map>

std::map <std::pair <int, int>, bool> mem;
std::map <std::pair <int, int>, std::vector <bool>> ans;

int ind_to_sort_byy = 0;

bool cmp(int i, int j) {
    if (mem[{i, j}]) return ans[{i, j}][ind_to_sort_byy];
    mem[{i, j}] = true; ans[{i, j}] = compare(i, j);
    return ans[{i, j}][ind_to_sort_byy];
}

std::vector <std::vector <int>> pointSort(int n, int k) {
    std::vector <std::vector <int>> res;
    std::vector <std::vector <int>> transposed;

    for (int b = 0; b < k; b++) {
        ind_to_sort_byy = b;
        std::vector <int> idxs; for (int i = 0; i < n; i++) idxs.push_back(i);
        std::sort(idxs.begin(), idxs.end(), cmp);
        std::vector <int> coords; for (int i = 0; i < n; i++) coords.push_back(0);

        for (int i = 0; i < n; i++) {
            coords[idxs[i]] = i;
        }

        transposed.push_back(coords);
    }

    for (int i = 0; i < n; i++) {
        std::vector <int> t;
        for (int b = 0; b < k; b++) {
            t.push_back(transposed[b][i]);
        }
        res.push_back(t);
    }

    return res;
}

