#include "pointsort.h"
#include <algorithm>
#include <iostream>
#include <vector>

//std::vector <std::vector <int>> pointSort(int n, int k) {
//    std::vector <std::vector <int>> res;
//
//    for (int i = 0; i < n; i++) {
//        std::vector <int> curr; for (int j = 0; j < k; j++) curr.push_back(0);
//
//        for (int j = 0; j < n; j++) {
//            if (i == j) continue;
//            std::vector <bool> r = compare(j, i);
//            for (int b = 0; b < k; b++) {
//                curr[b] += r[b];
//            }
//        }
//        res.push_back(curr);
//    }
//
//    return res;
}

int ind_to_sort_byy = 0;

bool cmp(int i, int j) {
    return compare(i, j)[ind_to_sort_byy];
}

std::vector <std::vector <int>> pointSort(int n, int k) {
    std::vector <std::vector <int>> res;
    std::vector <std::vector <int>> transposed;

    for (int b = 0; b < k; b++) {
        ind_to_sort_byy = b;
        std::vector <int> idxs; for (int i = 0; i < n; i++) idxs.push_back(i);
        std::sort(idxs.begin(), idxs.end(), cmp);
        std::vector <int> coords; for (int i = 0; i < n; i++) coords.push_back(0);

        for (int i = 0; i < n; i++) {
            coords[idxs[i]] = i;
        }

        transposed.push_back(coords);
    }

    for (int i = 0; i < n; i++) {
        std::vector <int> t;
        for (int b = 0; b < k; b++) {
            t.push_back(transposed[b][i]);
        }
        res.push_back(t);
    }

    return res;
}
