#include <bits/stdc++.h>
using namespace std;

#ifndef LOCAL
#define cerr if(false)cerr
#endif

#define endl "\n"
#define out(x) #x << " = " << x << " "

const int MAX_M = 1e5 + 10;
const int MAX_N = 1e5 + 10;

int n, m;
int buck[MAX_N];

struct Pair {
    int a, b, sum;

    void print () {
        cerr << "(" << a << ", " << b << " - " << sum << ")" << endl;
    }
};

bool cmp (Pair a, Pair b) {
    if (a.a == b.a) return a.b < b.b;
    return a.a < b.a;
}

vector <Pair> v;
long long pref[MAX_N];

int binaryFrom (int a, int b) {
    int l = 0, r = v.size() - 1, mid, ans = -1;

    while (l <= r) {
        mid = (l + r) / 2;
        if (v[mid].a > a || (v[mid].a == a && v[mid].b > b)) {
            r = mid - 1;
        } else if (v[mid].a == a && v[mid].b == b) {
            ans = mid;
            r = mid - 1;
        } else {
            l = mid + 1;
        }
    }

    return ans;
}

int binaryTo (int a, int b) {
    int l = 0, r = v.size() - 1, mid, ans = -1;

    while (l <= r) {
        mid = (l + r) / 2;
        if (v[mid].a > a || (v[mid].a == a && v[mid].b > b)) {
            r = mid - 1;
        } else if (v[mid].a == a && v[mid].b == b) {
            ans = mid;
            l = mid + 1;
        } else {
            l = mid + 1;
        }
    }

    return ans;
}

signed main () {
    // ios_base::sync_with_stdio(false); cin.tie(nullptr);

    cin >> n >> m;

    for (int i = 0; i < m; i++) {
        int k; cin >> k;

        for (int j = 0; j < k; j ++) {
            cin >> buck[j];
        }
        for (int j = 0; j < k; j ++) {
            for (int x = j + 1; x < k; x ++) {
                int a = buck[j];
                int b = buck[x];
                if (a > b) swap(a, b);

                v.push_back({a, b, i + 1});
            }
        }
    }

    sort(v.begin(), v.end(), cmp);
    //v[0].print();

    pref[0] = v[0].sum;
    for (int i = 1; i < v.size(); i ++) {
        pref[i] = pref[i - 1] + v[i].sum;
    }

    int q; cin >> q;

    for (int i = 0; i < q; i ++) {
        int a, b; cin >> a >> b;
        if (a > b) swap(a, b);

        int from = binaryFrom(a, b);
        int to = binaryTo(a, b);

        if (from == -1 || to == -1) {
            cout << 0 << endl;
            continue;
        }

        if (from - 1 < 0) cout << pref[to] << endl;
        else cout << pref[to] - pref[from - 1] << endl;
    }

    return 0;
}
