#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int N = 1e5 + 5;
const int S = 1e5 + 5;
const int M = S / 2;

int n, m;
vector <int> in[N];

vector <int> where[N];

int query(int a, int b)
{
    int ptra = 0, ptrb = 0;
    int ret = 0;

    while (ptra < where[a].size() && ptrb < where[b].size())
    {
        if (where[a][ptra] == where[b][ptrb])
        {
            ret += where[a][ptra];
            ret++;
            ptra++, ptrb++;
        }
        else
        {
            if (where[a][ptra] < where[b][ptrb])
            {
                ptra++;
            }
            else
            {
                ptrb++;
            }
        }
    }

    return ret;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;

    for (int i = 0; i < m; i++)
    {
        int k;

        cin >> k;

        in[i].resize(k);

        for (int q = 0; q < k; q++)
        {
            cin >> in[i][q];

            where[in[i][q]].push_back(i);
        }
    }

    /**for (int i = 0; i < m; i++)
    {
        for (int q = 0; q < in[i].size(); q++)
        {
            cout << in[i][q] << " ";
        }

        cout << endl;
    }**/

    int t;

    cin >> t;

    while (t--)
    {
        int a, b;

        cin >> a >> b;

        cout << query(a, b) << endl;
    }

    return 0;
}
