#include <bits/stdc++.h>
#include "pointsort.h"
///#include "Lgrader.cpp"

using namespace std;

int min_point[5], max_point[5];
int ans[10005][5];
int id[10005];

vector <int> v;
map < pair <int, int>, int > mp;
vector < vector <bool> > questions;

void dq(int l, int r, int d)
{
    if (l == r)
    {
        return;
    }

    int mid = l + r >> 1;

    dq(l, mid, d);
    dq(mid + 1, r, d);

    int ll = l, rr = mid + 1;

    v.clear();

    while (ll <= mid && rr <= r)
    {
        vector <bool> p;

        if (mp.find({id[ll], id[rr]}) != mp.end())
        {
            p = questions[mp[{id[ll], id[rr]}]];
        }
        else
        {
            p = compare(id[ll] - 1, id[rr] - 1);
            questions.push_back(p);
            mp[{id[ll], id[rr]}] = questions.size() - 1;
            mp[{id[rr], id[ll]}] = questions.size() - 1;
        }

        if (p[d] == 0)
        {
            v.push_back(id[rr]);
            rr++;
        }
        else
        {
            v.push_back(id[ll]);
            ll++;
        }
    }

    if (ll == mid + 1)
    {
        while (rr <= r)
        {
            v.push_back(id[rr]);
            rr++;
        }
    }
    else
    {
        while (ll <= mid)
        {
            v.push_back(id[ll]);
            ll++;
        }
    }

    for (int i = l; i <= r; i++)
    {
        id[i] = v[i - l];
    }
}

std::vector<std::vector<int>> pointSort(int n, int k)
{
    mp.clear();
    questions.clear();

    for (int i = 0; i < k; i++)
    {
        for (int q = 1; q <= n; q++)
        {
            id[q] = q;
        }

        dq(1, n, i);

        for (int q = 1; q <= n; q++)
        {
            ans[id[q]][i] = q;
        }
    }

    vector < vector < int > > ret;

    for (int i = 1; i <= n; i++)
    {
        vector <int> push;

        for (int q = 0; q < k; q++)
        {
            push.push_back(ans[i][q] - 1);
        }

        ret.push_back(push);
    }

    return ret;
}
