#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

const int MAXN = 1e3 + 10;
const int MAXM = 1e5 + 10;

int n, m, q;

vector < int > in[MAXN];
vector < int > kosh[MAXM];

ll ans[MAXN][MAXN];

void read()
{
    cin >> n >> m;

    for(int i = 1; i <= m; i++)
    {
        int k;
        cin >> k;

        for(int j = 1; j <= k; j++)
        {
            int mush;
            cin >> mush;
            kosh[i].push_back(mush);
            in[mush].push_back(i);
        }
    }
}

void solve()
{
    for(int i = 1; i <= n; i++)
    {
        int sz = in[i].size();

        for(int j = 0; j < sz; j++)
        {
            for(int x : kosh[in[i][j]])
            {
                ans[i][x] += in[i][j];
            }
        }
    }
}

void process_queries()
{
    cin >> q;

    for(int i = 1; i <= q; i++)
    {
        int a, b;
        cin >> a >> b;

        cout << ans[a][b] << endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
    process_queries();
    return 0;
}
