#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

const int MAXN = 1e5 + 10;

int n;
int wants[MAXN];
int has[MAXN];
int trans[MAXN];
int ad[MAXN];

int L, R, len;
bool lampa;

void init(std::vector<int> kids, const std::vector<int>candies)
{
    n = kids.size();

    for(int i = 0; i < n; i++)
    {
        wants[i] = kids[i];
        has[i] = candies[i];
    }
}

bool check()
{
    for(int i = 0; i < n; i++)
    {
        ad[i] = 0;
    }
    /**
    cout << "Checking : " << endl;
    for(int i = 0; i < n; i++)
    {
        cout << trans[i] << " ";
    }
    cout << endl;

    */

    for(int i = L; i <= R; i++)
    {
        ad[i] = has[i] - trans[i];
    }

    for(int i = L; i <= R; i++)
    {
        int nxt = i + 1;

        if(i == R)
            nxt = L;

        ad[nxt] += trans[i];
    }
    /**
    for(int i = 0; i < n; i++)
    {
        cout << ad[i] << " ";
    }
    cout << endl;
    */
    for(int i = L; i <= R; i++)
    {
        if(ad[i] < wants[i])
            return false;
    }

    return true;
}

void try_all(int pos)
{
    if(lampa)
        return;

    if(pos == R + 1)
    {
        if(check())
            lampa = true;

        return;
    }

    for(int i = 0; i <= has[pos]; i++)
    {
        trans[pos] = i;
        try_all(pos + 1);
        trans[pos] = 0;
    }
}

bool isValid(int l, int r)
{
    L = l;
    R = r;
    len = r - l + 1;
    lampa = false;

    for(int i = 0; i < n; i++)
    {
        trans[i] = 0;
        ad[i] = 0;
    }

    /**

    cout << "Wants : " << endl;
    for(int i = 0; i < n; i++)
    {
        cout << wants[i] << " ";
    }
    cout << endl;

    cout << "Has : " << endl;
    for(int i = 0; i < n; i++)
    {
        cout << has[i] << " ";
    }
    cout << endl;

    */

    try_all(L);

    return lampa;
}

void update(int l, int r, int x, int y)
{
    for(int i = l; i <= r; i++)
    {
        wants[i] = x;
        has[i] = y;
    }
}
