#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

const int MAXN = 1e4 + 10;

int n;
int wants[MAXN];
int has[MAXN];
int ad[MAXN];

void calc()
{
    for(int i = 0; i < n; i++)
    {
        int right = (i + 1 + n) % n;

        ad[i] = has[i] + has[right];
    }
}

void init(std::vector<int> kids, const std::vector<int>candies)
{
    n = kids.size();

    for(int i = 0; i < n; i++)
    {
        wants[i] = kids[i];
        has[i] = candies[i];
    }

    calc();
}

bool isValid(int l, int r)
{
    for(int i = l; i <= r; i++)
    {
        if(ad[i] < wants[i])
            return false;
    }

    return true;
}

void update(int l, int r, int x, int y)
{
    for(int i = l; i <= r; i++)
    {
        wants[i] = x;
        has[i] = y;
    }

    calc();
}
