/*
    Nakude dushata mi da byaga
    I kude da skrie svoite sulzi
*/

#include "candies.h"
#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>

typedef long long llong;
const int MAXN = 200000 + 10;
const int MAXLOG = 18;
const int INF = 1e9;

int n;
int a[MAXN];
int b[MAXN];
// int s[MAXN];
// int c[MAXN];
void init(std::vector <int> A, std::vector <int> B)
{
    n = A.size();
    for (int i = 1 ; i <= n ; ++i)
    {
        a[i] = A[i - 1];
        b[i] = B[i - 1];
    }
}

bool isValid(int l, int r)
{
    l++; r++;
    llong sum = 0;
    for (int i = l ; i <= r ; ++i)
    {
        sum += b[i];
        sum -= a[i];
    }

    if (sum < 0)
    {
        return false;
    }

    for (int i = l ; i <= r ; ++i)
    {
        llong sum = 0;
        int idx = i;
        for (int step = 1 ; step <= r - l ; ++step)
        {
            idx = (idx == r ? l : idx + 1);
            sum += b[idx] - a[idx];
            if (sum + b[i] < 0)
            {
                return false;
            }
            
        }
    }
    
    return true;
}

void update(int l, int r, int x, int y)
{
    l++; r++;
    for (int i = l ; i <= r ; ++i)
    {
        a[i] = x;
        b[i] = y;
    }
}