/*
    Nakude dushata mi da byaga
    I kude da skrie svoite sulzi
*/

#include "candies.h"
#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>

typedef long long llong;
const int MAXN = 200000 + 10;
const int MAXLOG = 18;
const int INF = 1e9;

int n;
int a[MAXN];
int b[MAXN];
int s[MAXN];
int c[MAXN];
void init(std::vector <int> A, std::vector <int> B)
{
    n = A.size();
    for (int i = 1 ; i <= n ; ++i)
    {
        s[i] = B[i - 1] - A[i - 1];
    }
}

bool isValid(int l, int r)
{
    l++; r++;
    for (int i = l ; i <= r ; ++i)
    {
        c[i] = s[i];
    }

    for (int i = l ; i <= r ; ++i)
    {
        int next = (i == r ? l : i + 1);
        if (c[i] < 0 && c[next] < 0)
        {
            return false;
        }
    }

    for (int i = l ; i <= r ; ++i)
    {
        int next = (i == r ? l : i + 1);
        if (c[i] + c[next] < 0)
        {
            return false;
        }

        if (c[i] < 0)
        {
            c[next] += c[i];
        }
    }

    return true;
}

void update(int l, int r, int x, int y)
{
    l++; r++;
    for (int i = l ; i <= r ; ++i)
    {
        s[i] = y - x;
    }
}