#include "pointsort.h"
#include<bits/stdc++.h>

#define MAXN 10007
using namespace std;

int nn,kk,ind;
vector<int> perm[MAXN];

vector<int> v[MAXN][5];
int deg[MAXN][5];

int currind;

bool cmp(int x,int y){
    auto res=compare(x,y);

    for(int i=0;i<kk;i++){
        if(res[i]){v[y][i].push_back(x); deg[x][i]++;}
        else {v[x][i].push_back(y); deg[y][i]++;}
    }

    return res[currind];
}

vector<int> bfs(int x,int ind){
    vector<int> res;

    for(int i:v[x][ind]){
        deg[i][ind]--;

        if(deg[i][ind]==0)res.push_back(i);
    }

    return res;
}

int maxs(vector<int> t,int ind){
    if(t.size()==1)return t[0];

    vector<int> l,r;
    int mid=int(t.size())/2;

    for(int i=0;i<mid;i++)l.push_back(t[i]);
    for(int i=mid;i<t.size();i++)r.push_back(t[i]);

    int x=maxs(l,ind);
    int y=maxs(r,ind);

    auto res=compare(x,y);

    for(int i=0;i<kk;i++){
        if(res[i]){v[y][i].push_back(x); deg[x][i]++;}
        else {v[x][i].push_back(y); deg[y][i]++;}
    }

    if(res[ind])return y;
    return x;
}

vector< vector<int> > pointSort(int N, int K){
    nn=N; kk=K;

    vector<int> s;
    for(int i=0;i<nn;i++){
        s.push_back(i);
        perm[i].clear();
    }

    for(int i=0;i<nn;i++){
        for(int f=0;f<kk;f++){
            v[i][f].clear();
            deg[i][f]=0;
        }
    }

    currind=0;
    sort(s.begin(),s.end(),cmp);

    for(int i=0;i<s.size();i++){
        perm[s[i]].push_back(i);
    }

    for(int i=1;i<kk;i++){
        vector<int> w;
        int num=nn-1;

        for(int f=0;f<nn;f++){
            if(deg[f][i]==0)w.push_back(f);
        }

        while(!w.empty()){

            if(w.size()>1){
                w={maxs(w,i)};
                while(w.size()>1)w.pop_back();
            }

            perm[w[0]].push_back(num); num--;
            w=bfs(w[0],i);
        }
    }

    vector< vector<int> > ans;
    for(int i=0;i<nn;i++)ans.push_back(perm[i]);

    return ans;
}