#include "pointsort.h"
#include<bits/stdc++.h>

#define MAXN 10007
using namespace std;

int nn,kk,ind;
vector<int> perm[MAXN];

vector<bool> res[10][MAXN];

void solve(int ind,vector<int> s,int l,int r){

    if(s.empty())return;
    if(l==r){
        perm[s[0]].push_back(l);
        return;
    }
    
    int pivot=-1;
    for(int i:s){
        if(i<7)pivot=i;
    }

    vector<int> ll,rr;

    if(pivot!=-1){

        for(int i:s){
            if(i==pivot)continue;
            
            if(res[pivot][i][ind]){
                rr.push_back(i);
            }else{
                ll.push_back(i);
            }
        }
    }else{
        pivot=s[0];

        for(int i:s){
            if(i==pivot)continue;

            if(compare(pivot,i)[ind]){
                rr.push_back(i);
            }else{
                ll.push_back(i);
            }
        }
    }


    int sz=int(ll.size());
    perm[pivot].push_back(l+sz);

    solve(ind,ll,l,l+sz-1);
    solve(ind,rr,l+sz+1,r);
}

vector< vector<int> > pointSort(int N, int K){
    nn=N; kk=K;

    vector<int> s;
    for(int i=0;i<nn;i++){
        s.push_back(i);
        perm[i].clear();
    }

    for(int i=0;i<7;i++){
        for(int f=0;f<nn;f++){
            if(i==f)continue;

            res[i][f]=compare(i,f);
        }
    }

    for(int i=0;i<kk;i++){
        solve(i,s,0,nn-1);
    }

    vector< vector<int> > ans;
    for(int i=0;i<nn;i++)ans.push_back(perm[i]);

    return ans;
}