// #define _GLIBCXX_FILESYSTEM

#include<bits/stdc++.h>
#define MAXN 200007
using namespace std;

int n;
int a[MAXN],b[MAXN],c[MAXN],d[MAXN];

void init(vector<int> kids, const vector<int> candies){
    n=int(kids.size());

    for(int i=1;i<=n;i++){
        a[i]=kids[i-1];
        b[i]=candies[i-1];
    }
}

bool isValid(int l, int r){
    l++; r++;

    if(l==r)return b[l]>=a[l];

    for(int i=l;i<=r;i++){
        c[i]=a[i]; d[i]=b[i];
    }
    c[l-1]=c[r];

    long long sum=0;
    for(int i=l;i<=r;i++){
        sum+=c[i-1]-a[i];
    }

    if(sum<0)return false;

    for(int i=l;i<=r;i++){
        long long s=sum-(c[i-1]-a[i]);
        s=-s;

        long long ll=s,rr=c[i-1]-a[i];
        if(ll>rr)return false;
    }

    for(int i=l;i<=r;i++){
        if(i>l and b[i-1]+b[i]<a[i])return false;
        if(i==l and b[r]+b[l]<a[i])return false;
    }

    for(int i=0;i<=d[r];i++){
        int curr=i;
        bool dali=true;

        for(int f=l;f<=r-1;f++){
            if(curr+d[f]<c[f]){
                dali=false; break;
            }

            c[f]-=curr;
            d[f]-=max(0,c[f]);
            curr=d[f];
        }

        if(curr+d[r]-i<c[r])dali=false;
        
        if(dali)return true;
    }

    return false;
}

void update(int l, int r, int x, int y){
    l++; r++;

    for(int i=l;i<=r;i++){
        a[i]=x; b[i]=y;
    }
}

/*int main(){

    init({2 ,0 ,9 ,4 ,1},{0 ,5 ,4 ,6 ,7});

    update(4,4,8,1);
    cout<<isValid(0,1)<<"\n";
    update(3,3,4,9);
    update(1,2,2,2);

    cout<<isValid(3,4)<<"\n";
    cout<<isValid(2,2)<<"\n";
    cout<<isValid(2,4)<<"\n";

    return 0;
}*/