// #define _GLIBCXX_FILESYSTEM

#include<bits/stdc++.h>
#define MAXN 200007
using namespace std;

int n;
int a[MAXN],b[MAXN];

void init(vector<int> kids, const vector<int> candies){
    n=int(kids.size());

    for(int i=1;i<=n;i++){
        a[i]=kids[i-1];
        b[i]=candies[i-1];
    }
}

bool isValid(int l, int r){
    l++; r++;

    if(l==r)return b[l]>=a[l];

    long long sum=0;
    for(int i=l;i<=r;i++){
        sum+=b[i]-a[i];
    }

    if(sum<0)return false;

    for(int i=l;i<=r;i++){
        long long s=sum-(b[i]-a[i]);
        s=-s;

        if(s>b[i]-a[i])return false;
    }

    for(int i=l;i<=r;i++){
       // sum+=b[i]-a[i];
        if(i>l and b[i-1]+b[i]<a[i])return false;
        if(i==l and b[r]+b[l]<a[i])return false;
    }


    return true;
}

void update(int l, int r, int x, int y){
    l++; r++;

    for(int i=l;i<=r;i++){
        a[i]=x; b[i]=y;
    }
}

/*int main(){

    init({2 ,0 ,9 ,4 ,1},{0 ,5 ,4 ,6 ,7});

    update(4,4,8,1);
    cout<<isValid(0,1)<<"\n";
    update(3,3,4,9);
    update(1,2,2,2);

    cout<<isValid(3,4)<<"\n";
    cout<<isValid(2,2)<<"\n";
    cout<<isValid(2,4)<<"\n";

    return 0;
}*/