#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const ll MAXN = 1e5 + 10;

int n, m;
vector < ll > basket[MAXN];
pair < ll, ll > task[MAXN];
void input()
{
    cin >> n >> m;
    for (int i = 1; i <= m; i ++)
    {
        int k;
        cin >> k;
        basket[i].resize(k);
        for (int j = 0; j < k; j ++)
            cin >> basket[i][j];
    }
}

const ll MAXMOD = 1e8 + 7;
ll sum_small[MAXMOD];

void small_baskets()
{
    for (int i = 1; i <= m; i ++)
    {
        int k = basket[i].size();
        for (int j = 0; j < k; j ++)
            for (int d = 0; d < k; d ++)
        {
            if (basket[i][j] >= basket[i][d])
                continue;

            sum_small[(basket[i][j] * MAXN +  basket[i][d]) % MAXMOD] += (ll)(i);
        }
    }
}

void answer_queries()
{
    int q;
    cin >> q;
    for (int i = 1; i <= q; i ++)
    {
        ll a, b;
        cin >> a >> b;
        if (a > b)
            swap(a, b);
        cout << sum_small[(a * MAXN + b) % MAXMOD] << endl;
    }
}
void solve()
{
    input();
    small_baskets();
    answer_queries();

}

int main()
{
    speed();
    solve();
    return 0;
}
