#include<bits/stdc++.h>
#include "pointsort.h"

using namespace std;
typedef long long ll;

const int MAXN = 1e4 + 10;

int cur_cor;


const int MAXK = 5;


vector < vector < int > > Points;
bool inserted[MAXK];
int pos[MAXK][MAXN], l[MAXK], r[MAXK], lg[MAXN];

mt19937 rng;
    vector < int > ord[MAXK];
const int WINDOW = 10;
int choose_m(int k, int i)
{
    if (i == 0)
        return -1;
    int pivot = -1;
    double best = 1e9;

    vector < int > pot;
    for (int c = 0; c < k; c ++)
    {
        int m = (l[c] + r[c]) / 2;
        ///cout << "here " << l[c] <<  " " << r[c] << endl;
        for (int j = max(l[c], m - WINDOW) + 1; j < min(r[c], m + WINDOW); j ++)
        {
            pot.push_back(ord[c][j]);
        }
    }
    ///cout << pot.size() << endl;
    for (int j : pot)
    {
        double sum = 0;
        for (int c = 0; c < k; c ++)
        {
            int cur_l = l[c], cur_r = r[c];
            int m = pos[c][j];

            if (m <= cur_l || m >= cur_r)
            {
                sum += lg[cur_r - cur_l - 1];
                continue;
            }

            int len1 = (m - cur_l - 1);
            int len2 = (cur_r - m - 1);
            if (len1 + len2 == 0)
                continue;
            double cont = ((double)(len1) * (double)lg[len1] + (double)(len2) * (double)(lg[len2]));
            cont /= (double)(len1 + len2);
            sum += cont;
        }
        if (sum < best)
        {
            pivot = j;
            best = sum;
        }
    }
    assert(i == 0 || pivot != -1);

    return pivot;
}
vector < vector < int > > pointSort(int n, int k)
{
    for (int i = 1; i <= n + 2; i ++)
    {
        lg[i] = lg[i / 2] + 1;
    }
    Points.clear();
    Points.resize(n);
    for (int i = 0; i < n; i ++)
        Points[i].resize(k);


    for (int i = 0; i < MAXK; i ++)
        ord[i].clear();
    int cmp_count = 0;
    for (int i = 0; i < n; i ++)
    {
        ///cout << i << " " << cmp_count << endl;
        for (int c = 0; c < k; c ++)
        {
            inserted[c] = false;
            for (int j = 0; j < (int)(ord[c].size()); j ++)
            {
                pos[c][ord[c][j]] = j;
            }
            l[c] = -1;
            r[c] = (int)(ord[c].size());
        }
        bool notDone = true;


        while(notDone)
        {
            notDone = false;


            vector < bool > check;
            int ver;
            for (int c = 0; c < k; c ++)
            {
                if (inserted[c])
                    continue;
                if (l[c] + 1 >= r[c])
                {
                    inserted[c] = true;
                    ord[c].insert(ord[c].begin() + r[c], i);

                    continue;
                }
                notDone = true;


                if (check.empty())
                {
                    ver = choose_m(k, i);
                         cmp_count ++;
                    check = compare(ver, i);
                }
                int m = pos[c][ver];


                if (check[c] == 1)
                    l[c] = max(l[c], m);
                else
                    r[c] = min(r[c], m);
            }
        }

    }

    for (int c = 0; c < k; c ++)
    {
        for (int i = 0; i < n; i ++)
            Points[ord[c][i]][c] = i;
    }
    return Points;
}
