#include<iostream>
#include<algorithm>
#include<vector>
#include<bitset>
#include<queue>
#include "pointsort.h"
using namespace std;
const int MAX_N=1e4;
bitset<10000>used[MAX_N];
vector<int>g[5][MAX_N];
int in[5][MAX_N];
int tmp[5][MAX_N];
int N,K;
vector<vector<int>>ans;
void doit(int d)
{
    queue<int>q;
    vector<int>order;

    for(int i=0;i<N;i++)
    {
        tmp[d][i]=in[d][i];
        if(tmp[d][i]==0)
        {
            q.push(i);
        }
    }

    while(q.size())
    {
        int u=q.front();
        order.push_back(u);
        q.pop();

        for(int&v:g[d][u])
        {
            if(--tmp[d][v]==0)q.push(v);
        }
    }

    for(int i=0;i<N;i++)
    {
        int u=order[i];

        ans[u][d]=i;
    }
}
bool okthis(int d)
{
    queue<int>q;

    for(int i=0;i<N;i++)
    {
        tmp[d][i]=in[d][i];
        if(tmp[d][i]==0)
        {
            q.push(i);
        }
    }

    while(q.size())
    {
        if(q.size()>1)return 0;

        int u=q.front();
        q.pop();

        for(int&v:g[d][u])
        {
            if(--tmp[d][v]==0)q.push(v);
        }
    }

    return 1;
}
bool okall()
{
    for(int i=0;i<K;i++)
    {
        if(!okthis(i))return 0;
    }
    return 1;
}
void query(int i,int j)
{
    if(i==j)return;

    if(used[i][j])return;

    used[i][j]=1;
    used[j][i]=1;

    auto ss=compare(i,j);

    for(int d=0;d<K;d++)
    {
        if(ss[d]==1)
        {
            in[d][j]++;
            g[d][i].push_back(j);
        }
        else
        {
            in[d][i]++;
            g[d][j].push_back(i);
        }
    }
}
vector<vector<int>> pointSort(int n, int k)
{
    N=n;
    K=k;

    for(int d=0;d<K;d++)
    {
        for(int i=0;i<N;i++)
        {
            g[d][i].clear();
            in[d][i]=0;
        }
    }

    for(int i=0;i<N-1;i++)
    {
        query(i,i+1);
    }

    int tt=2000000;
    while(tt--)
    {
        int i=rand()%N;
        int j=rand()%N;

        query(i,j);
    }

    ans.clear();
    ans.resize(N);
    for(int i=0;i<N;i++)ans[i].resize(K);

    for(int d=0;d<K;d++)doit(d);

    return ans;
}
