#include"pointsort.h"
#include<bits/stdc++.h>
using namespace std;
#define MAXN 10004
unordered_map<long long, vector<bool>> quers;
int mks;
int naklk[MAXN];
vector<bool> compare1(int i, int j)
{
    //return compare(i,j);
    //if (i>j) swap(i,j);
    if (quers.find(1LL*i*(mks)+j)!=quers.end()) return quers[ 1LL*i*(mks)+j ];
    vector<bool> ans=compare(i,j);
    quers[ 1LL*i*(mks)+j ]=ans;
    return ans;
}
bool compareCh(int i, int j)
{
    if (quers.find(1LL*i*(mks)+j)!=quers.end()) return true;
    return false;
}
vector<int> msort(vector<int> &koi, int dm);
vector<int> qsort(vector<int> &koi, int dm);
vector<vector<int>> otg;
vector<vector<int>> pointSort(int N, int K)
{
    //srand(time(NULL));
    int n,k;
    n=N;
    k=K;
    mks=n;
    otg.resize(n);
    for (int q=0;q<n;q++) otg[q].resize(k);
        vector<int> vlizat;
        for (int w=0;w<n;w++) vlizat.push_back(w);
        //random_shuffle(vlizat.begin(),vlizat.end());
    for (int q=0;q<k;q++)
    {
        vector<int> chs=msort(vlizat,q);
        for (int w=0;w<n;w++) otg[ chs[w] ][q]=w;
    }
    quers.clear();
    return otg;
}
/*
15 10000 2
1
101
102
103
104
105
106
107
108
109
110
111
112
114
113
115
*/
vector<int> qsort(vector<int> &koi, int dm)
{
    if (koi.size()==0)
    {
        vector<int> vv;
        return vv;
    }
    if (koi.size()==1)
    {
        vector<int> vv;
        vv.push_back(koi[0]);
        return vv;
    }
    int pvt=0;
    vector<int> levi;
    vector<int> desni;
    for (int q=0;q<koi.size();q++)
    {
        if (q==pvt) continue;
        if (pvt<q)
        {
            vector<bool> ans=compare1(koi[pvt],koi[q]);
            if (ans[dm]==1) desni.push_back(koi[q]);
            else levi.push_back(koi[q]);
        }
        else
        {
            vector<bool> ans=compare1(koi[q],koi[pvt]);
            if (ans[dm]==0) desni.push_back(koi[q]);
            else levi.push_back(koi[q]);
        }
    }
    vector<int> lvo=qsort(levi,dm);
    vector<int> dno=qsort(desni,dm);
    vector<int> obsht;
    for (int q=0;q<lvo.size();q++) obsht.push_back(lvo[q]);
    obsht.push_back(koi[pvt]);
    for (int q=0;q<dno.size();q++) obsht.push_back(dno[q]);
    return obsht;
}
vector<int> msort(vector<int> &koi, int dm)
{
    if (koi.size()==1)
    {
        vector<int> vv;
        vv.push_back(koi[0]);
        return vv;
    }
    int mid=(koi.size()-1)/2;
    vector<int> levi;
    vector<int> levis;
    for (int q=0;q<=mid;q++) levis.push_back(koi[q]);
    if (levis.size()>0) levi=msort(levis,dm);
    else levi=qsort(levis,dm);
    vector<int> desni;
    vector<int> desnis;
    for (int q=mid+1;q<koi.size();q++) desnis.push_back(koi[q]);
    if (desnis.size()>0) desni=msort(desnis,dm);
    else desni=qsort(desnis,dm);
    vector<int> obsht;
    int lv=0,ds=0;
    while (true)
    {
        if (lv==levi.size() && ds==desni.size()) break;
        if (lv==levi.size())
        {
            obsht.push_back(desni[ds]);
            ds++;
            continue;
        }
        if (ds==desni.size())
        {
            obsht.push_back(levi[lv]);
            lv++;
            continue;
        }
        int ed=levi[lv],dv=desni[ds];
        if (ed<dv)
        {
            bool nm=false;
            bool da=false;
            for (int q=1;q<=5;q++)
            {
                int rd=ed+q;
                if (rd>=dv) break;
                if (compareCh(ed,rd) && compareCh(rd,dv))
                {
                    vector<bool> ans1=compare1(ed,rd);
                    vector<bool> ans2=compare1(rd,dv);
                    if (ans1[dm] && ans2[dm])
                    {
                        nm=true;
                        da=true;
                        break;
                    }
                    else if (!ans1[dm] && !ans2[dm])
                    {
                        nm=true;
                        da=false;
                        break;
                    }
                }
            }
            for (int q=1;q<=5;q++)
            {
                int rd=dv-q;
                if (rd<=ed) break;
                if (compareCh(ed,rd) && compareCh(rd,dv))
                {
                    vector<bool> ans1=compare1(ed,rd);
                    vector<bool> ans2=compare1(rd,dv);
                    if (ans1[dm] && ans2[dm])
                    {
                        nm=true;
                        da=true;
                        break;
                    }
                    else if (!ans1[dm] && !ans2[dm])
                    {
                        nm=true;
                        da=false;
                        break;
                    }
                }
            }
            vector<bool> ans;
            ans.resize(dm+1);
            if (!nm) ans=compare1(ed,dv);
            else ans[dm]=da;
            if (ans[dm]==1)
            {
                obsht.push_back(ed);
                lv++;
            }
            else
            {
                obsht.push_back(dv);
                ds++;
            }
        }
    }
    return obsht;
}
