#include "pointsort.h"
#include<bits/stdc++.h>

using namespace std;

const int MAXN=10005;

int n,k;
char cmp[MAXN][MAXN][5];
vector<int> v;
int cur=0;
vector<int> tmp;

bool comp(int x,int y)
{
    if(cmp[x][y][cur]==1) return 0;
    else if(cmp[x][y][cur]==2) return 1;
    else
    {
        vector<bool> c=compare(x,y);
        for(int i=0;i<k;i++)
        {
            if(c[i]==0) 
            {
                cmp[x][y][i]=1;
                cmp[y][x][i]=2;
            }
            else
            {
                cmp[x][y][i]=2;
                cmp[y][x][i]=1;
            }
        }
        if(cmp[x][y][cur]==1) return 0;
        else return 1;
    }
}

void mergeSort(int l,int r)
{
    //cout<<l<<" "<<r<<" ";
    if(l>=r) return;

    int mid=(l+r)/2;
    mergeSort(l,mid);
    mergeSort(mid+1,r);

    tmp.clear();
    int ptrl=l, ptrr=mid+1;
    while(ptrl<=mid && ptrr<=r)
    {
        if(comp(v[ptrl],v[ptrr]))
        {
            tmp.push_back(v[ptrl]);
            ptrl++;
        }
        else
        {
            tmp.push_back(v[ptrr]);
            ptrr++;
        }
    }
    while(ptrl<=mid)
    {
        tmp.push_back(v[ptrl]);
        ptrl++;
    }
    while(ptrr<=r)
    {
        tmp.push_back(v[ptrr]);
        ptrr++;
    }

    for(int i=l;i<=r;i++) v[i]=tmp[i-l];
}

std::vector<std::vector<int>> pointSort(int _n, int _k)
{
    n=_n;
    k=_k;
    for(int i=0;i<n;i++)
    {
        for(int j=0;j<n;j++)
        {
            for(int h=0;h<k;h++) cmp[i][j][h]=0;
        }
    }

    vector<vector<int> > ans;
    ans.resize(n);
    for(int i=0;i<n;i++) ans[i].resize(k);

    v.resize(n,0);
    tmp.reserve(n);
    for(int i=0;i<k;i++)
    {
        for(int j=0;j<n;j++) v[j]=j;
        cur=i;
        mergeSort(0,n-1);
//cout<<endl<<i<<endl;
        for(int j=0;j<n;j++)
        {
            ans[v[j]][i]=j;
        }
    }

    return ans;
}