#include "candies.h"
#include<bits/stdc++.h>

using namespace std;

const int MAXN=2e5+5;

int n;
int a[MAXN];
int b[MAXN];
long long prefa[MAXN]; ///
long long prefb[MAXN];

long long suma(int l,int r)
{
    return prefa[r]-prefa[l-1];
}

long long sumb(int l,int r)
{
    return prefb[r]-prefb[l-1];
}

bool check(int ind,int len,int l,int r)
{
    //cout<<l<<" "<<r<<" "<<len<<" "<<ind<<" - ";
    int le=min(len, ind-l+1);
    long long sa=suma(ind-le+1,ind);
    if(le<len) sa+=suma(r-(len-le)+1,r);
    len++;
    le=min(len, ind-l+1);
    long long sb=sumb(ind-le+1,ind);
    if(le<len) sb+=sumb(r-(len-le)+1,r);
    //cout<<sa<<" "<<sb<<endl;
    return sa<=sb;
}

void init(std::vector<int> kids, const std::vector<int> candies)
{
    n=kids.size();
    for(int i=0;i<n;i++)
    {
        a[i+1]=kids[i];
        b[i+1]=candies[i];
    }
    prefa[0]=prefb[0]=0;
    for(int i=1;i<=n;i++)
    {
        prefa[i]=prefa[i-1]+a[i];
        prefb[i]=prefb[i-1]+b[i];
    }
}

bool isValid(int l, int r)
{
    l++, r++;
    int len=r-l+1;
    if(suma(l,r)>sumb(l,r)) return 0;
    for(int i=len-1;i>=len/2-1;i--)
    {
        for(int j=l;j<=r;j++)
        {
            if(check(j,i,l,r)==0) return 0;
        }
    }
    return 1;
}

void update(int l, int r, int x, int y)
{
    l++, r++;
    for(int i=l;i<=r;i++)
    {
        a[i]=x;
        b[i]=y;
    }
    prefa[0]=prefb[0]=0;
    for(int i=1;i<=n;i++)
    {
        prefa[i]=prefa[i-1]+a[i];
        prefb[i]=prefb[i-1]+b[i];
    }
}