#include <bits/stdc++.h>
using namespace std;

template< class T, class T2 > inline bool chkmin( T& a, const T2&b ){ return a > b ? a = b, 1 : 0;}
template< class T, class T2 > inline bool chkmax( T& a, const T2&b ){ return a < b ? a = b, 1 : 0;}


#ifndef LOCAL
#define cerr if( false ) cerr
#endif // LOCAL

#define out( x ) #x << " = " << x << "  "
#define endld "\n"

typedef long long ll;

const int MAX_N = 1e5 + 42;
const int mod = 1e7 + 9;

std::vector< int > v[128];
ll prec[128][128];

int main() {
#ifndef LOCAL
std::ios_base::sync_with_stdio(false); std::cin.tie(NULL); std::cout.tie(NULL);
#endif // LOCAL

    ll n, q, m;
    std::cin >> n >> m;

    for( int i=1 ; i <= m ; i ++ ){
        int k;
        std::cin >> k;
        for( int j=0 ; j < k ; j++ ){
            int curr;
            std::cin >> curr;
            v[curr].push_back( i );
        }
    }

    for( int a=1 ; a <= n ; a ++ ){
        for( int b=a ; b <= n ; b ++ ){
            ll nas = 0;

            int ind1, ind2;
            ind1 = ind2 = 0;
            int A = v[a].size();
            int B = v[b].size();
            while( ind1 < A and ind2 < B ){
                cerr << out( ind1 ) << out( ind2 ) << endl;
                if( v[a][ind1] == v[b][ind2] ){
                    nas += v[a][ind1];
                    ind1 ++;
                    ind2 ++;
                    continue;
                }
                if( v[a][ind1] < v[b][ind2] ) ind1 ++;
                else ind2 ++;
            }
            prec[a][b] = nas;
            cerr << out( a ) << out( b ) << out( nas ) << endl;
        }
    }

    std::cin >> q;
    while( q --> 0 ){
        int a, b;
        std::cin >> a >> b;
        if( a > b ) std::swap( a, b );
        cerr << out( a ) << out( b ) << out( prec[a][b] ) << endl;
        std::cout << prec[a][b] << endl;
    }

    return 0;
}
