#include "pointsort.h"
#include <algorithm>
#include <iostream>
#include <bits/stdc++.h>
using namespace std;

template< class T, class T2 > inline bool chkmin( T& a, const T2&b ){ return a > b ? a = b, 1 : 0;}
template< class T, class T2 > inline bool chkmax( T& a, const T2&b ){ return a < b ? a = b, 1 : 0;}


#ifndef LOCAL
#define cerr if( false ) cerr
#endif // LOCAL

#define out( x ) #x << " = " << x << "  "
#define endld "\n"

typedef long long ll;

const int MAX_N = 7e3+ 42;
const int mod = 1e7 + 9;









mt19937 myGen( 420 );

int K;
std::vector< int > v[5][MAX_N];
int comp[MAX_N][MAX_N];

int currT = 1;
int viz[MAX_N];
void dfs( int x, int curr ){
    cerr << out( x ) << out( curr ) << endl;
    comp[curr][x] = 1;
    comp[x][curr] = 0;
    viz[curr] = currT;

    for( auto j : v[K][curr] ){
        if( viz[j] < currT ){
            dfs( x, j );
        }
    }
}

int KK;
bool makeQ( int a, int b ){
    cerr << out( a ) << out( b ) << out( comp[a][b] ) << endl;

    if( comp[a][b] != -1 ) return comp[a][b];

    auto query = compare( a, b );
    for( int i=0 ; i < KK ; i++ ){
        // a < b
        cerr << out( query[i] ) << out( a ) << out( b ) << endl;
        if( query[i] ) v[i][b].push_back( a );
        else v[i][a].push_back( b );
    }

    currT ++;
    // a < b
    if( query[K] ) dfs( b, b );
    else dfs( a, a );

    cerr << out( comp[a][b] ) << endl;
    return comp[a][b];
}

void sol( int kk, int l, int r, std::vector< int >& v ){


    if( l == r ) return;
    int m = ( l + r ) >> 1;

    std::vector< int > left, right;
    for( int i=l ; i <= r ; i++ ){
        if( i <= m ) left.push_back( v[i-l] );
        else right.push_back( v[i-l] );
    }


    sol( kk, l, m, left );
    sol( kk, m+1, r, right );

    int ind1, ind2;
    ind1 = ind2 = 0;
    int A = left.size();
    int B = right.size();


    cerr << " left " << endl;
    for( auto j : left ) cerr << j <<" ";
    cerr << endl;

    cerr << " right " << endl;
    for( auto j : right ) cerr << j <<" ";
    cerr << endl << endl;
    std::vector< int > nas;
    while( ind1 < A || ind2 < B ){

        cerr << out( ind1 ) << out( ind2 ) << endl;
        if( ind1 == A ){
            nas.push_back( right[ind2] );
            ind2 ++;
            continue;
        }
        if( ind2 == B ){
            nas.push_back( left[ind1] );
            ind1 ++;
            continue;
        }


        bool curr = makeQ( left[ ind1 ], right[ ind2 ] );


        // left < right
        if( curr ){
            nas.push_back( left[ind1++] );
        }else{
            nas.push_back( right[ind2++] );
        }
    }
    cerr << "nas" << endl;
    for( auto j : nas ) cerr << j << " ";
    cerr << endl;

    v = nas;
}

std::vector<std::vector<int>> pointSort(int n, int k){

    for( int kk=0 ; kk < k ; kk ++ ){
        for( int i=0 ; i <= n ; i++ ) v[kk][i].clear();
    }

    KK = k;
    std::vector<std::vector<int>> nas;
    nas.resize( n );
    for( int i=0 ; i < n ; i++ ) nas[i].resize( k );
    cerr << out( n ) << out( k ) << endl;
    for( int i=0 ; i < k ; i++ ){
        std::vector< int > ind( n );
        std::iota( ind.begin(), ind.end(), 0 );

        K = i;
        for( int kk = 0 ; kk <= n ; kk ++ ){
            for( int ii=0 ; ii <= n ; ii++ ){
                comp[kk][ii] = -1;
            }
        }

        for( int j=0 ; j < n ; j++ ) dfs( j,j );

        sol( i, 0, n-1, ind );

        for( auto j : ind ) cerr << j << " ";
        cerr << endl;

        for( int j=0 ; j < n ; j++ ){
            nas[ind[j]][i] = j;
        }
    }

    cerr << "!!" << endl;
    for( int i=0 ; i < n ; i++ ){
        for( int j=0 ; j < k ; j++ ) cerr << nas[i][j] << " ";
        cerr << endl;
    }
    cerr << endl << endl;

    return nas;
}

