#include <bits/stdc++.h>

#include "candies.h"

using namespace std;

template< class T, class T2 > inline bool chkmin( T& a, const T2&b ){ return a > b ? a = b, 1 : 0;}
template< class T, class T2 > inline bool chkmax( T& a, const T2&b ){ return a < b ? a = b, 1 : 0;}


#ifndef LOCAL
#define cerr if( false ) cerr
#endif // LOCAL

#define out( x ) #x << " = " << x << "  "
#define endld "\n"

typedef long long ll;

const int MAX_N = 1e6 + 42;
const int mod = 1e7 + 9;

int N;
int a[MAX_N];
int b[MAX_N];
void init(std::vector<int> kids, const std::vector<int> candies){
    N = kids.size();
    for( int i=0 ; i < N ; i++ ) a[i] = kids[i];
    for( int i=0 ; i < N ; i++ ) b[i] = candies[i];
}
bool isValid(int l, int r){
    int st = -1;

    bool oke = true;
    int mx = -1;
    for( int i=l ; i <= r ; i++ ){
        int c = b[i] - a[i];
        if( chkmax( mx, c ) ){
            st = i;
        }
        if( c < 0 ) oke = false;
    }

    if( oke ) return true;
    cerr << "ananasko" << endl;

    if( l == r-1 ){
        if( b[l] >= a[l] and b[r] >= a[r] ) return true;
        if( b[l] > a[l] ){
            if( b[r] + ( b[l] - a[l] ) > a[r] ) return true;
        }else{
            if( b[l] + ( b[r] - a[r] ) > a[l] ) return true;
        }

        return false;
    }

    int ost = mx;
    for( int i=( st +1 ) % N ; i != st ; i = ( i + 1 ) % N ){
        int currB = b[i] + ost;

        cerr << out( i ) << out( ost ) << out( currB ) << out( a[i] ) << endl;
        if( currB < a[i] ) return false;
        ost = b[i] - std::max( 0, a[i] - ost );
        if( i == r ) i = l-1;
    }
    return true;
}
void update(int l, int r, int x, int y){
    for( int i=l ; i <= r ; i++ ){
        a[i] = x;
        b[i] = y;
    }
}



signed main() {
	std::ios_base::sync_with_stdio(false); std::cin.tie(NULL);
	int64_t n, q;
	std::cin >> n;
	std::vector<int> kids(n), candies(n);
	for (int64_t i = 0; i < n; i ++) { std::cin >> kids[i]; }
	for (int64_t i = 0; i < n; i ++) { std::cin >> candies[i]; }
	init(kids, candies);

	const int64_t mod = 1e9 + 7;
	std::vector<bool> ret;

	std::cin >> q;
	while (q --) {
		int64_t t;
		std::cin >> t;
		if (t == 1) {
			int64_t l, r;
			std::cin >> l >> r;
			const auto ans = isValid(l, r);
			ret.push_back(ans);
		} else if (t == 2) {
			int64_t l, r, x, y;
			std::cin >> l >> r >> x >> y;
			update(l, r, x, y);
		} else {
			assert(false);
		}
	}

	for (int64_t i = 0; i < ret.size(); i ++) {
		std::cout << (bool)ret[i] << std::endl;;
	}
	return 0;
}
