#include <iostream>
#include <vector>
#include "pointsort.h"



std::vector<std::vector<int> > merging(int from, int to, std::vector<std::vector<int> > vec[2], int k) {
    std::vector<std::vector<int> > ans;
    for (int i = 0; i < k; i++) {
        ans.push_back({});
    }
    for (int d = 0; d < k; d++) {
        int i = 0, j = 0;
        while (1) {
            if (i == vec[0][d].size()) {
                for (; j < vec[1][d].size(); j++) {
                    ans[d].push_back(vec[1][d][j]);
                }
                break;
            }
            if (j == vec[1][d].size()) {
                for (; i < vec[0][d].size(); i++) {
                    ans[d].push_back(vec[0][d][i]);
                }
                break;
            }
            std::vector<bool> comp = compare(vec[0][d][i], vec[1][d][j]);
            if (comp[d]) {
                ans[d].push_back(vec[0][d][i]);
                i++;
            } else {
                ans[d].push_back(vec[1][d][j]);
                j++;
            }
        }
    }
    return ans;
}
std::vector<std::vector<int> > solve(int from, int to, int k) {
    if (from == to) {
        std::vector<int> ans;
        for (int i = 1; i <= k; i++) {
            ans.push_back(from);
        }
        std::vector<std::vector<int> > izhod = {ans};
        return izhod;
    }
    std::vector<std::vector<int> > vec[2];
    vec[0] = solve(from, (from + to) / 2, k);
    vec[1] = solve((from + to) / 2 + 1, to, k);
    return merging(from, to, vec, k);
}


std::vector<std::vector<int> > pointSort(int n, int k) {
    std::vector<std::vector<int> > vec = solve(0, n - 1, k);
    std::vector<std::vector<int> > ans;
    for (int i = 0; i < k; i++) {
        ans.push_back({});
        for (int j = 0; j < n; j++) {
            ans[vec[i][j]][i] = j;
        }
    }
    return ans;
}
