#include <bits/stdc++.h>

#include "candies.h"



std::vector<int> deca,mashini;
void init(std::vector<int> kids, std::vector<int> candies)
{
    deca=kids;
    mashini=candies;
}
int vpref[100],kpref[100];
bool isValid(int l, int r)
{
    bool ans=true; // std::cout<<"huh";
    long long sumMachines=0, sumChildren=0;
    if(l==r)
    {
        return deca[r]<=mashini[r];
    }
    if((r-l)==1)
    {
        return (deca[l]+deca[l+1])<=(mashini[l]+mashini[l+1]);
    }
    vpref[0]=0;
    kpref[0]=0;
    for(int i=1;i<mashini.size();i++){
        vpref[i]=vpref[i-1]+mashini[i];
        kpref[i]=kpref[i-1]+deca[i];
    }
    for(int i=l; i<=r; i++)
    {
        //  std::cout<<i;
        sumChildren+=deca[i];
        sumMachines+=mashini[i];


        if( deca[i]>(mashini[i]+mashini[(i-l+1)%(r-l)+l]))
        {
            //    std::cout<<2;
            //std::cout<<" "<<l<<" 1"<<r<<"\n";
            return false;
        }
        if(i<r && sumChildren>(sumMachines+mashini[(i-l+1)%(r-l)+l]))
        {
            //std::cout<<" "<<l<<" 2"<<r<<"\n";
            return false;
        }
//        if(0>(std::min((mashini[i]-deca[i]),0) + mashini[(i-l+1)%(r-l)+l] + mashini[(i-l+2) % (r-l)+l+1] - deca[(i-l+1) % (r-l)+l]))
//        {
//            //std::cout<<" "<<l<<" 3"<<r<<"\n";
//            return false;
//        }
    }
    for(int o=l;o<r;o++){
        for(int t=o+1;t<r;t++){
          if((kpref[t+1]-kpref[o])>(vpref[t+1]-vpref[o]+mashini[o+1])){
            return false;
          }
        }

    }
    if(sumMachines<sumChildren)
    {
        return false;
    }


    return true;
}
void update(int l, int r, int x, int y)
{
    for(int i=l; i<=r; i++)
    {
        deca[i]=x;
        mashini[i]=y;
    }
}
signed main()
{
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(NULL);
    int64_t n, q;
    std::cin >> n;
    std::vector<int> kids(n), candies(n);
    for (int64_t i = 0; i < n; i ++)
    {
        std::cin >> kids[i];
    }
    for (int64_t i = 0; i < n; i ++)
    {
        std::cin >> candies[i];
    }
    init(kids, candies);

    const int64_t mod = 1e9 + 7;
    std::vector<bool> ret;

    std::cin >> q;
    while (q --)
    {
        int64_t t;
        std::cin >> t;
        if (t == 1)
        {
            int64_t l, r;
            std::cin >> l >> r;
            const auto ans = isValid(l, r);
            ret.push_back(ans);
        }
        else if (t == 2)
        {
            int64_t l, r, x, y;
            std::cin >> l >> r >> x >> y;
            update(l, r, x, y);
        }
        else
        {
            assert(false);
        }
    }

    for (int64_t i = 0; i < ret.size(); i ++)
    {
        std::cout << (bool)ret[i] << std::endl;;
    }
    return 0;
}
