#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXE = 1e7+50;
const int MAXN = 1e5+50;

int64_t ans[MAXE];
bool hasQuery[MAXN];
int K[MAXN];

map <pair <int, int>, int> mp;
vector <int> mushrooms[MAXN];
vector <pair<int, int>> queries;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int N, M, i, j, k, l, m;
    pair <int, int> p;
    l = 0;

    cin >> N >> M;
    for (i = 0; i < M; i++)
    {
        cin >> K[i];
        mushrooms[i].reserve(K[i]);
        for (j = 0; j < K[i]; j++)
        {
            cin >> m;
            mushrooms[i].push_back(m);
        }
    }

    int Q, L, R;
    cin >> Q;
    for (i = 0; i < Q; i++)
    {
        cin >> L >> R;

        if (L > R)
            swap(L, R);

        p = {L, R};
        if (mp.find(p) == mp.end())
            mp[p] = l++;

        hasQuery[L] = hasQuery[R] = 1;
        queries.emplace_back(p);
    }

    for (i = 0; i < M; i++)
    {
        for (j = 0; j < K[i]; j++)
        {
            if (hasQuery[mushrooms[i][j]] == false)
                continue;

            for (k = j+1; k < K[i]; k++)
            {
                if (hasQuery[mushrooms[i][k]] == false)
                    continue;

                p = {mushrooms[i][j], mushrooms[i][k]};

                if (p.first > p.second)
                    swap(p.first, p.second);

                if (mp.find(p) == mp.end())
                    continue;

                //cout << p.first << " " << p.second << " " << i+1 << endl;
                ans[mp[p]] += (i+1);

            }
        }
    }

    for (auto q:queries)
    {
        cout << ans[mp[q]] << endl;
    }
    return 0;
}

/*
6 3
3 1 2 3
2 5 6
3 2 5 6
4
1 2
2 5
3 6
5 6
*/
