#include <bits/stdc++.h>
#include "candies.h"
using namespace std;

const int maxn = 2e5+2;
int n;
long long a[maxn], b[maxn], ca[maxn], cb[maxn];

void init(std::vector<int> kids, const std::vector<int> candies)
{
    n = (int)(kids.size());
    int i;
    for (i=1; i<=n; ++i)
    {
        a[i] = (long long)(kids[i-1]);
        b[i] = (long long)(candies[i-1]);
    }
}

bool isValid(int l, int r)
{
    ++ l; ++ r;

    long long suma = a[l], sumb = b[l];
    if (a[l] > b[l] + b[r])
        return false;
    int i;
    for (i=l+1; i<=r; ++i)
    {
        if (a[i] > b[i] + b[i-1])
            return false;

        suma += a[i];
        sumb += b[i];
    }
    if (suma > sumb)
        return false;

    // pairs
    if (a[r]+a[l] > b[r-1]+b[r]+b[l])
        return false;
    if (a[l]+a[l+1] > b[r]+b[l]+b[l+1])
        return false;
    for (i=l+1; i<r; ++i)
    {
        if (a[i]+a[i+1] > b[i-1]+b[i]+b[i+1])
            return false;
    }



    for (i=l; i<=r; ++i)
        ca[i] = a[i], cb[i] = b[i];

    for (i=l; i<=r; ++i)
    {
        if (ca[i] < cb[i])
        {
            cb[i] -= ca[i];
            ca[i] = 0;
        }
        else
        {
            ca[i] -= cb[i];
            cb[i] = 0;
        }
    }

    if (ca[l] < cb[r])
    {
        cb[r] -= ca[l];
        ca[l] = 0;
    }
    else
    {
        ca[l] -= cb[r];
        cb[r] = 0;
    }
    for (i=l+1; i<=r; ++i)
    {
        if (ca[i] < cb[i-1])
        {
            cb[i-1] -= ca[i];
            ca[i] = 0;
        }
        else
        {
            ca[i] -= cb[i-1];
            cb[i-1] = 0;
        }
    }

    for (i=l; i<=r; ++i)
    {
        if (ca[i] > 0)
            return false;
    }
    return true;
}

void update(int l, int r, int x, int y)
{
    ++ l; ++ r;
    int i;
    for (i=l; i<=r; ++i)
    {
        a[i] = x;
        b[i] = y;
    }
}