#include <bits/stdc++.h>
#include "candies.h"
using namespace std;

const int maxn = 2e5+2;
int n, a[maxn], b[maxn];

void init(std::vector<int> kids, const std::vector<int> candies)
{
    n = (int)(kids.size());
    int i;
    for (i=1; i<=n; ++i)
    {
        a[i] = kids[i-1];
        b[i] = candies[i-1];
    }
}

bool isValid(int l, int r)
{
    ++ l; ++ r;

    long long suma = (long long)(a[l]), sumb = (long long)(b[l]);
    if (a[l] > b[l] + b[r])
        return false;
    int i;
    for (i=l+1; i<=r; ++i)
    {
        if (a[i] > b[i] + b[i-1])
            return false;
        suma += (long long)(a[i]);
        sumb += (long long)(b[i]);
    }

    if (suma > sumb)
        return false;
    return true;
}

void update(int l, int r, int x, int y)
{
    ++ l; ++ r;
    int i;
    for (i=l; i<=r; ++i)
    {
        a[i] = x;
        b[i] = y;
    }
}