#include "candies.h"
#include <vector>
#include<iostream>
using namespace std;

vector<int>a,b;

void init(vector<int> kids, const vector<int> candies){
    a = kids,b = candies;
}

bool isValid(int l, int r) {
    bool isValid = false;
    vector<int> br = b;

    if(a[l] > br[l] + br[r])
        return false;

    if(a[l] > br[r])
        br[l] -= (a[l] - br[r]), br[r]=0;
    else
        br[r] -=a[l];

    for(int i=l+1;i<=r;i++){
        if(a[i] > br[i-1] + br[i])
            return false;

        if(a[i] > br[i-1])
            br[i] -= (a[i]-br[i-1]), br[i-1] = 0;
        else
            br[i-1] -= a[i];
    }

    return true;
}

void update(int l, int r, int x, int y){
    for(int i=l;i<=r;i++)
        a[i] = x, b[i] = y;
}
