# include <iostream>
# include <bitset>
# include <vector>
# include <algorithm>
# include <map>
using namespace std;

const int MAX=1e5+1,bl_sz=300,S=bl_sz+1;

int n,m,q;
bitset<S> b[MAX];
vector<int> a[MAX];
pair<int,int> z[MAX];
map<pair<int,int>,int> mp;
long long out[MAX];

int getL(int x) {return (x-1)*bl_sz+1;}
int getR(int x) {return min(m,bl_sz*x);}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    cin>>n>>m;
    for(int i=1;i<=m;i++)
    {
        int k;
        cin>>k;
        while(k--)
        {
            int x;
            cin>>x;
            a[i].push_back(x);
        }

        sort(a[i].begin(),a[i].end());
    }

    cin>>q;
    for(int i=1;i<=q;i++)
    {
        int u,v;
        cin>>u>>v;
        if(u>v) swap(u,v);
        mp[{u,v}]=i;
    }

    for(int i=1;i<=m;i++)
    {
        int sz=a[i].size();
        for(int j=1;j<sz;j++)
        {
            for(int k=0;k<j;k++) out[mp[{a[i][k],a[i][j]}]]+=i;
        }
    }

    for(int i=1;i<=q;i++) cout<<out[i]<<"\n";

    return 0;
}



