# include <iostream>
# include <vector>
# include <algorithm>
# include <random>
# include <map>
using namespace std;
# include "pointsort.h"
//# include "Lgrader.cpp"

const int MAX=1e4+11;

int curr_k;
map<pair<int,int>,bool> vis;
map<pair<int,int>,vector<bool>> Data;

bool cmp(int x, int y)
{
    if(x==y) return false;
    if(vis.find({x,y})!=vis.end())
    {
        return Data[{x,y}][curr_k];
    }
    else if(vis.find({y,x})!=vis.end())
    {
        return !Data[{y,x}][curr_k];
    }
    else
    {
        vector<bool> resp=compare(x,y);
        vis[{x,y}]=1;
        Data[{x,y}]=resp;
        return Data[{x,y}][curr_k];
    }
}

vector<vector<int>> pointSort(int n, int k)
{
    vector<vector<int>> res;
    res.resize(n);
    for(int j=0;j<n;j++) res[j].resize(k);

    for(int j=0;j<k;j++)
    {
        curr_k=j;
        vector<int> v;
        for(int i=0;i<n;i++) v.push_back(i);
        sort(v.begin(),v.end(),cmp);

        for(int i=0;i<n;i++) res[v[i]][j]=i;
    }

    return res;
}
