# include <iostream>
# include <vector>
# include <algorithm>
# include <random>
# include <map>
using namespace std;
# include "pointsort.h"
//# include "Lgrader.cpp"

const int MAX=2e4+11;

int curr_k;
map<pair<int,int>,bool> vis;
map<pair<int,int>,vector<bool>> Data;

bool cmp(int x, int y)
{
    if(x==y) return false;
    if(vis.find({x,y})!=vis.end())
    {
        return Data[{x,y}][curr_k];
    }
    else if(vis.find({y,x})!=vis.end())
    {
        return !Data[{y,x}][curr_k];
    }
    else
    {
        vector<bool> resp=compare(x,y);
        vis[{x,y}]=1;
        Data[{x,y}]=resp;
        return Data[{x,y}][curr_k];
    }
}

int val[MAX][5];

vector<vector<int>> pointSort(int n, int k)
{
    vector<vector<int>> res;
    res.resize(k);
    for(int i=0;i<k;i++)
    {
        curr_k=i;
        for(int j=0;j<n;j++) res[i].push_back(j);
        sort(res[i].begin(),res[i].end(),cmp);
    }

    for(int i=0;i<k;i++)
    {
        for(int j=0;j<n;j++)
        {
            val[res[i][j]][i]=j;
        }
    }

    vector<vector<int>> res2;
    res2.resize(n);
    for(int i=0;i<n;i++)
    {
        for(int j=0;j<k;j++) res2[i].push_back(val[i][j]);
    }

    return res2;
}
