# include <iostream>
# include <vector>
# include <algorithm>
using namespace std;
# include "candies.h"
//# include "Lgrader.cpp"

const int MAX=1e6+11;

int n;
int a[MAX];
int b[MAX];
int a2[MAX];
int b2[MAX];

void init(int l, int r)
{
    for(int i=l;i<=r;i++)
    {
        a2[i]=a[i];
        b2[i]=b[i];
    }
}

bool check(int l, int r, int start)
{
    bool f=1;

    for(int i=start;i<=r;i++)
    {
        if(a2[i]>b2[i]) f=0;

        int nxt=i+1;
        if(nxt==r+1) nxt=l;
        a2[nxt]-=b2[i]-a2[i];
        a2[nxt]=max(0,a2[nxt]);
    }

    for(int i=l;i<start;i++)
    {
        if(a2[i]>b2[i]) f=0;

        int nxt=i+1;
        if(nxt==r+1) nxt=l;
        a2[nxt]-=b2[i]-a2[i];
        a2[nxt]=max(0,a2[nxt]);
    }

    return f;
}

bool isValid(int l, int r)
{
    int val=l;
    for(int i=l;i<=r;i++)
    {
        if(b[i]-a[i]>b[val]-a[val]) val=i;
    }

    init(l,r);
    return check(l,r,val);
}

void update(int l, int r, int x, int y)
{
    for(int i=l;i<=r;i++)
    {
        a[i]=x;
        b[i]=y;
    }
}

void init(std::vector<int> kids, const std::vector<int> candies)
{
    n=kids.size();
    for(int i=0;i<n;i++)
    {
        a[i]=kids[i];
        b[i]=candies[i];
    }
}
