#include <bits/stdc++.h>
#include "pointsort.h"
using namespace std;
const long long MAXN=10009;
long long r,N,K;
vector<int> edg[7][MAXN];
vector<int> ob[7][MAXN];
long long sz[MAXN];
vector<int> v;
bool so(int i,int j)
{
    auto vS=compare(i,j);
    for(int k=r+1; k<K; k++)
    {
        if(vS[k]==1)
        {
            edg[k][i].push_back(j);
            ob[k][j].push_back(i);
        }
        else
        {
            edg[k][j].push_back(i);
            ob[k][i].push_back(j);
        }
    }
    return vS[r];
}

void topo(int a)
{
    queue<int> q;
    for(int i=0; i<N; i++)
    {
        sz[i]=edg[a][i].size();
        if(edg[a][i].size()==0)
        {
            q.push(i);
        }
    }

    while(!q.empty())
    {
        int start=q.front();
        q.pop();
        v.push_back(start);
        for(auto t:ob[a][start])
        {
            sz[t]--;
            if(sz[t]==0)q.push(t);
        }
    }
    reverse(v.begin(),v.end());
}

std::vector<std::vector<int>> pointSort(int n, int k)
{
    for(int i=0; i<MAXN; i++)for(int j=0; j<7; j++)
        {
            edg[j][i].clear();
            ob[j][i].clear();
        }
    N=n;
    K=k;
    vector<vector<int>> ans;
    for(int i=0; i<n; i++)
    {
        ans.push_back({});
        for(int j=0; j<k; j++)ans[i].push_back(0);
    }
    for(int i=0; i<k; i++)
    {
        r=i;
        topo(i);
        sort(v.begin(),v.end(),so);
        for(int j=0; j<n; j++)ans[v[j]][i]=j;
        v.clear();
    }

    return ans;
}
