#include <bits/stdc++.h>
#include "candies.h"
using namespace std;
const long long MAXN=200009;
long long N;
long long a[MAXN];
long long b[MAXN];

inline long long min1(long long a,long long b)
{
    if(a>b)return b;
    return a;
}

void init(std::vector<int> kids, const std::vector<int>candies)
{
    N=kids.size();
    for(int i=0;i<N;i++)
    {
        b[i]=candies[i];
        a[i]=kids[i];
    }
}

bool tryAll(int l,int r,int x)
{
    int left=b[r]-x;
    for(int i=l;i<r;i++)
    {
        if(a[i]<left)left=b[i];
        else left=b[i]-(a[i]-left);
        if(left<0)return 0;
    }
    if(left+x<a[r])return 0;
    return 1;
}

bool isValid(int l, int r)
{
    int left=b[r];
    int minLeft=b[r];
    for(int i=l;i<=r;i++)
    {
        if(a[i]<left)
        {
            int u=left-a[i];
            if(u<=minLeft)
            {
                minLeft-=u;
                left-=u;
            }
            else
            {
                left-=minLeft;
                minLeft=0;
            }
        }
        else
        {
            left=b[i]-(a[i]-left);
            minLeft=min1(minLeft,left);
        }
        if(left<0)return 0;
    }
    return 1;
}

void update(int l, int r, int x, int y)
{
    for(int i=l;i<=r;i++)
    {
        a[i]=x;
        b[i]=y;
    }
}
