#define _GLIBCXX_FILESYSTEM
#include<bits/stdc++.h>
#include "pointsort.h"
#define endl "\n"
int n,k;
std::vector<int> Sorting[5];
std::unordered_map<int,std::vector<bool> > mem;
void mergeSort(int l,int r){
    if(l==r) return;
    if(l+1==r){
        std::vector<bool> cmp = compare(l,r);
        for(int i=0;i<k;i++){
            if(!cmp[i]) std::swap(Sorting[i][l],Sorting[i][r]);
        }
        return;
    }
    int mid = (l+r)>>1;
    mergeSort(l,mid);
    mergeSort(mid+1,r);
    for(int d=0;d<k;d++){
        std::vector<int> newOrder;
        int m1=l,m2=mid+1;
        while(m1<=mid && m2<=r){
            std::vector<bool> cmp;
            if(mem.find(Sorting[d][m1]*n+Sorting[d][m2])!=mem.end()) cmp = mem[Sorting[d][m1]*n+Sorting[d][m2]];
            else{
                cmp = compare(Sorting[d][m1],Sorting[d][m2]);
                mem[Sorting[d][m1]*n+Sorting[d][m2]] = cmp;
            }
            if(cmp[d]){
                newOrder.push_back(Sorting[d][m1]);
                m1++;
            }
            else{
                newOrder.push_back(Sorting[d][m2]);
                m2++;
            }
        }
        while(m1<=mid){
            newOrder.push_back(Sorting[d][m1]);
            m1++;
        }
        while(m2<=r){
            newOrder.push_back(Sorting[d][m2]);
            m2++;
        }
        for(int i=0;i<newOrder.size();i++){
            Sorting[d][i+l] = newOrder[i];
        }
    }
}
std::vector<std::vector<int> > pointSort(int N,int K){
    mem.clear();
    n = N;
    k = K;
    for(int d=0;d<k;d++){
        Sorting[d].resize(n);
        for(int i=0;i<n;i++){
            Sorting[d][i]=i;
        }
    }
    mergeSort(0,n-1);
    std::vector<std::vector<int> > ans(n);
    for(int d=0;d<k;d++){
        for(int i=0;i<n;i++){
            ans[Sorting[d][i]].push_back(i);
        }
    }
    /*std::cout<<std::endl;
    for(auto x: ans){
        for(int i=0;i<k;i++){
            std::cout<<x[i]<<" ";
        }
        std::cout<<std::endl;
    }*/
    return ans;
}
