# define _GLIBCXX_FILESYSTEM
# include <bits/stdc++.h>
# define ll long long
using namespace std;

const int MAXN = 1e5 + 1;
multiset<pair<int, int>> List[MAXN];
int N, M;

void Upgrade_Speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N >> M;

    for(int i = 0; i < M; i++)
    {
        vector<int> V;
        int Size; cin >> Size;

        for(int j = 0; j < Size; j++)
        {
            int Value; cin >> Value;
            V.push_back(Value);
        }

        for(int j = 0; j < Size; j++)
        {
            for(auto& Value : V)
            {
                List[V[j]].insert({Value, i + 1});
            }
        }
    }
}

void Solve()
{
    int Q; cin >> Q;

    while(Q--)
    {
        int X, Y; cin >> X >> Y;
        int Answer = 0;

        for(auto& U : List[X])
        {
            if(U.first > Y) break;
            if(U.first < Y) continue;
            Answer += (U.second);
        }

        cout << Answer << '\n';
    }
}

int main()
{
    Upgrade_Speed();
    Read();
    Solve();
    return 0;
}
