# define _GLIBCXX_FILESYSTEM
# include <bits/stdc++.h>
# define ll long long
using namespace std;

const int MAXM = 1e5 + 1;
const int MAXN = 101;
int N, M;
vector<int> Graph[2 * MAXM + 1];

void Upgrade_Speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N >> M;

    for(int i = 0; i < M; i++)
    {
        int Size; cin >> Size;

        for(int j = 0; j < Size; j++)
        {
            int Value; cin >> Value;
            Graph[i + 1 + MAXM].push_back(Value);
            Graph[Value].push_back(i + 1 + MAXM);
        }
    }
}

void Solve()
{
    int Q; cin >> Q;

    while(Q--)
    {
        int X, Y; cin >> X >> Y;
        int Answer = 0;

        for(auto& V : Graph[X])
        {
            for(auto& U : Graph[V])
            {
                if(U == Y)
                {
                    Answer += (V - MAXM);
                    break;
                }
            }
        }

        cout << Answer << '\n';
    }
}

int main()
{
    Upgrade_Speed();
    Read();
    Solve();
    return 0;
}
