# define _GLIBCXX_FILESYSTEM
# include "pointsort.h"
# include <bits/stdc++.h>
using namespace std;

const int MAXN = 1e4 + 1;
int N, K, D;
int A[MAXN];
bool MEMO[MAXN][MAXN][2];
bool Visited[MAXN][MAXN];


bool Compare(const int& i, const int& j)
{
    vector<bool> Answer = compare(i, j);
    if(!Visited[i][j])
    {
        Visited[i][j] = true;
        Answer = compare(i, j);
        for(int k = 0; k < K; k++) MEMO[i][j][k] = Answer[k];
    }

    if(MEMO[i][j][D] == 0) return false;
    return true;
}

vector<vector<int>> pointSort(int n, int k)
{
    N = n;
    K = k;
    vector<vector<int>> Answer;
    Answer.resize(N);

    for(int i = 0; i < N; i++)
    {
        Answer[i].resize(K);
    }

    for(int d = 0; d < K; d++)
    {
        for(int i = 0; i < N; i++) A[i] = i;
        D = d;

        sort(A, A + N, Compare);

        for(int i = 0; i < N; i++)
        {
            Answer[A[i]][d] = i;
        }
    }

    return Answer;
}
