# define _GLIBCXX_FILESYSTEM
# include "pointsort.h"
# include <bits/stdc++.h>
using namespace std;

int N, K, D;
const int MAXN = 101;
vector<int> A;
vector<bool> Queries[MAXN][MAXN];
vector<vector<int>> pointSort(int n, int k)
{
    N = n;
    K = k;
    vector<vector<int>> Answer;
    Answer.resize(N);


    for(int i = 0; i < N; i++)
    {
        Answer[i].resize(K);

        for(int j = 0; j < N; j++)
        {
            if(i == j) continue;
            Queries[i][j] = compare(i, j);
        }
    }


    for(int d = 0; d < K; d++)
    {
        A.clear();
        for(int i = 0; i < N; i++) A.push_back(i);

        for(int i = 0; i < N; i++)
        {
            for(int j = i + 1; j < N; j++)
            {
                if(Queries[A[i]][A[j]][d] == 0) swap(A[i], A[j]);
            }
        }

        for(int i = 0; i < N; i++)
        {
            Answer[A[i]][d] = i;
        }
    }

    return Answer;
}

