#include "pointsort.h"
#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1e4+5;

vector<vector<int> >p;
int a[MAXN],b[MAXN];
map<pair<int,int> , vector<bool > > mymap;

vector<bool>get(int i, int j)
{
    if(i > j) swap(i,j);

    if(mymap.find({i,j}) == mymap.end()) mymap[{i,j}] = compare(i,j);
    return mymap[{i,j}];
}

void Merge_sort(int l, int r, int d)
{
    if(l >= r) return;

    int mid = (l+r)/2;

    Merge_sort(l,mid+0,d);
    Merge_sort(mid+1,r,d);

    int pl = l;
    int pr = mid+1;
    int p = l;

    /*cout << endl;
    cout << endl;
    cout << l << " " << r << endl;
    for(int i = l; i <= r; i++) cout << a[i] << " ";
    cout << endl;*/

    while(pl <= mid && pr <= r)
    {
        vector<bool>pom = get(a[pl],a[pr]);
        if(pom[d]) b[p] = a[pl++];
        else b[p] = a[pr++];

        p++;
    }


    while(pl <= mid)
    {
        b[p] = a[pl++];
        p++;
    }
    while(pr <= r)
    {
        b[p] = a[pr++];
        p++;
    }
    for(int i = l; i <= r; i++) a[i] = b[i];


    /*cout << "after merge" << endl;
    for(int i = l; i <= r; i++) cout << a[i] << " ";
    cout << endl;*/


}

std::vector<std::vector<int>> pointSort(int n, int k)
{
    mymap.clear();
    p.clear();
    p.resize(n);
    for(int i = 0; i < n; i++) p[i].resize(k);


    for(int j = 0; j < k; j++)
    {
        for(int i = 0; i < n; i++) a[i] = i;
        Merge_sort(0,n-1,j);

        for(int i = 0; i < n; i++) p[a[i]][j] = i;
    }
    return p;
}
