#define _GLIBCXX_FILESYSTEM
#include <bits/stdc++.h>

using namespace std;

const int maxn = 1005;

int n, m, q;
vector<int> a[maxn];
int ans[maxn][maxn];
unordered_set<int> where[maxn];

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> m;

    for (int i = 1; i <= m; ++i)
    {
        int k;
        cin >> k;

        for (int j = 0; j < k; ++j)
        {
            int x;
            cin >> x;
            a[x].push_back(i);
            where[x].insert(i);
        }
    }

    for (int i = 1; i <= n; ++i)
    {
        for (int j = i; j <= n; ++j)
        {
            for (auto x : a[i])
            {
                if (where[j].find(x) != where[j].end())
                {
                    ans[i][j] += x;
                }
            }
        }
    }

    cin >> q;

    for (int i = 1; i <= q; ++i)
    {
        int x, y;
        cin >> x >> y;
        if (x > y) swap(x, y);
        cout << ans[x][y] << "\n";
    }

    return 0;
}
