#include <iostream>
#include <vector>

using namespace std;

const int maxn = 200005;

int a[maxn], b[maxn];
int n;

void init(vector<int> kids, const vector<int> candies)
{
    n = kids.size();

    for (int i = 1; i <= n; ++i)
    {
        a[i] = kids[i - 1];
        b[i] = candies[i - 1];
    }
}

bool check(int l, int r, long long want)
{
    if (want > b[r]) return false;
    long long leftL = min(1LL * b[l], b[l] + want - a[l]);

    for (int i = r; i > l; --i)
    {
        long long curr = b[i] - want;
        long long adjCandies = (i - 1 == l ? leftL : b[i - 1]);
        if (a[i] - curr > adjCandies)
        {
            return false;
        }
        long long need = max(0LL, a[i] - curr);
        want = need;
    }

    return true;
}

bool isValid(int l, int r)
{
    ++l;
    ++r;

    if (l == r)
    {
        return a[l] <= b[l];
    }

    /*for (int i = l; i <= r; ++i)
    {
        cout << a[i] << " " << b[i] << endl;
    }*/

    if (check(l, r, max(0, a[l] - b[l])) == true) return true;
    if (check(l, r, min(b[r], a[l])) == true) return true;
    return false;
}

void update(int l, int r, int x, int y)
{
    ++l;
    ++r;

    for (int i = l; i <= r; ++i)
    {
        a[i] = x;
        b[i] = y;
    }
}
