#include <iostream>
#include <vector>

using namespace std;

const int maxn = 200005;

int a[maxn], b[maxn];
int n;

void init(vector<int> kids, const vector<int> candies)
{
    n = kids.size();

    for (int i = 1; i <= n; ++i)
    {
        a[i] = kids[i - 1];
        b[i] = candies[i - 1];
    }
}

bool isValid(int l, int r)
{
    ++l;
    ++r;

    if (l == r)
    {
        return a[l] <= b[l];
    }

    /*for (int i = l; i <= r; ++i)
    {
        cout << a[i] << " " << b[i] << endl;
    }*/

    long long want = max(0, a[l] - b[l]);
    if (want > b[r]) return false;
    want = max(want, want + b[r] - a[r]);
    long long leftL = b[l] + want - a[l];

    for (int i = r; i > l; --i)
    {
        long long curr = b[i] - want;
        long long adjCandies = (i - 1 == l ? leftL : b[i - 1]);
        if (a[i] - curr > adjCandies) return false;
        long long need = max(0LL, a[i] - curr);
        want = need;
    }

    return true;
}

void update(int l, int r, int x, int y)
{
    ++l;
    ++r;

    for (int i = l; i <= r; ++i)
    {
        a[i] = x;
        b[i] = y;
    }
}
