#include <bits/stdc++.h>
#include "pointsort.h"

#define maxn 10000

typedef long long ll;
typedef std::pair <int , int> pii;


std::map <pii , std::vector <bool>> used;
std::vector <bool> v;

std::vector <bool> cc;;
int dim;
std::vector<std::vector <int>> sorted;
std::unordered_map <int , bool> did[maxn];

std::vector <bool> my_query(int a , int b)
{
    if(did[a][b] == true)
        return used[{a , b}];

    cc = compare(a , b);
    used[{a , b}] = cc;
    did[a][b] = true;

    return used[{a , b}];
}


std::vector <bool> pom;
bool cmp(int a , int b)
{
    if(a == b)
        return true;
    pom = my_query(a , b);
    return pom[dim];
}

std::vector<std::vector<int>> pointSort(int n, int k)
{
    std::vector<std::vector <int>> ans;

    ans.resize(n);

    for(int i = 0; i < n; i++)
        ans[i].resize(k);

    sorted.resize(k);
    for(int i = 0; i < k; i++)
    {
        sorted[i].resize(n);
        dim = i;
        for(int j = 0; j < n; j++)
            sorted[i][j] = j;

        std::sort(sorted[i].begin() , sorted[i].end() , cmp);
        for(int j = 0; j < n; j++)
            ans[sorted[i][j]][i] = j;
    }


    return ans;
}
