#include <bits/stdc++.h>
#include "pointsort.h"

typedef long long ll;
typedef std::pair <int , int> pii;


std::map <pii , std::vector <bool>> used;
std::map <pii , bool> did;
std::vector <bool> v;

void my_query(int a , int b , std::vector <bool>& curr)
{
    if(used.count({a , b}))
    {
        curr = used[{a , b}];
        return;
    }

    v = compare(a , b);
    used[{a , b}] = v;
    curr = v;
    /**for(int i = 0; i < v.size(); i++)
        v[i] = !v[i];
    used[{b , a}] = v;*/

    return;
}



int dim;
std::vector<std::vector <int>> sorted;

std::vector <bool> pom;
bool cmp(int a , int b)
{
    if(a == b)
        return true;
    my_query(a , b , pom);
    return pom[dim];
}

std::vector<std::vector<int>> pointSort(int n, int k)
{
    std::vector<std::vector <int>> ans;

    ans.resize(n);

    for(int i = 0; i < n; i++)
        ans[i].resize(k);

    sorted.resize(k);
    for(int i = 0; i < k; i++)
    {
        sorted[i].resize(n);
        dim = i;
        for(int j = 0; j < n; j++)
            sorted[i][j] = j;

        std::sort(sorted[i].begin() , sorted[i].end() , cmp);
        for(int j = 0; j < n; j++)
            ans[sorted[i][j]][i] = j;
    }


    return ans;
}
