#include <bits/stdc++.h>
#include "candies.h"

#define maxn 200005

typedef long long ll;
typedef std::pair <int, int> pii;



int n, m;
int a[maxn], b[maxn];

void init(std::vector<int> kids, const std::vector<int> candies)
{
    n = kids.size();
    m = kids.size();
    for(int i = 0; i < kids.size(); i++)
        a[i] = kids[i];
    for(int i = 0; i < candies.size(); i++)
        b[i] = candies[i];
}

int hl, hr;
int getl(int x)
{
    if(x == hl)
        return hr;
    else
        return x - 1;
}

int save[maxn], savea[maxn];
int excess[maxn];

bool isValid(int l, int r)
{
    hl = l;
    hr = r;

    for(int i = 0; i < n; i++)
    {
        save[i] = b[i];
        savea[i] = a[i];
    }

    for(int i = l; i <= r; i++)
        excess[i] = std::max(0, b[i] - a[i]);

    int br;
    for(int i = l; i <= r; i++)
    {
        if(excess[getl(i)] != 0)
        {
            br = std::min(a[i], excess[getl(i)]);
            a[i] -= br;
            b[getl(i)] -= br;
            excess[getl(i)] -= br;
        }

        if(a[i] == 0)
            continue;

        int minl = std::min(a[i], b[getl(i)]);
        //std::cout << minl << " ";
        a[i] -= minl;
        b[getl(i)] -= minl;

        if(a[i] == 0)
            continue;

        minl = std::min(a[i], b[i]);
        //std::cout << minl << "\n";
        a[i] -= minl;
        b[i] -= minl;

        if(a[i] != 0)
        {
            for(int i = 0; i < n; i++)
                b[i] = save[i];
            for(int i = 0; i < n; i++)
                a[i] =savea[i];
            return false;
        }
    }

    for(int i = 0; i < n; i++)
        b[i] = save[i];
    for(int i = 0; i < n; i++)
        a[i] =savea[i];

    return true;
}

void update(int l, int r, int x, int y)
{
    for(int i = l; i <= r; i++)
    {
        a[i] = x;
        b[i] = y;
    }
}
