#include <algorithm>
#include <iostream>
#include <vector>

int n, m, q;
int req[169][169];
bool exists_mushroom[100069][169];

bool is_in(int a, int ind) {
    return exists_mushroom[a][ind];
}

int compute_req(int a, int b) {
    if (m > 100) return req[a][b];

    int ans = 0;
    for (int i = 1; i <= m; i++) {
        if (is_in(a, i) && is_in(b, i)) ans += i;
    }

    return ans;
}

int main() {
    std::cin >> n >> m;

    if (m > 100) {
        for (int i = 1; i <= m; i++) {
            int k; std::cin >> k;
            std::vector <int> v;
            for (int j = 0; j < k; j++) {
                int t; std::cin >> t;
                for (int el: v) {
                    req[el][t] += i;
                    req[t][el] += i;
                }
                v.push_back(t);
            }
        }
    } else {
        for (int i = 1; i <= m; i++) {
            int k; std::cin >> k;
            for (int j = 0; j < k; j++) {
                int t; std::cin >> t;
                exists_mushroom[t][i] = true;
            }
        }
    }

    std::cin >> q;

    for (int i = 0; i < q; i++) {
        int a, b; std::cin >> a >> b;
        std::cout << compute_req(a, b) << std::endl;
    }
}
