#include <algorithm>
#include <iostream>
#include <vector>

int n, m, q;
std::vector <int> mushrooms[100069];

//bool is_in(int a, int ind) {
//    for (int i: mushrooms[ind]) {
//        if (i == a) return true;
//    }
//    return false;
//}

bool is_in(int a, int ind) {
    return std::binary_search(mushrooms[ind].begin(), mushrooms[ind].end(), a);
}

int compute_req(int a, int b) {
    int ans = 0;
    for (int i = 1; i <= m; i++) {
        if (is_in(a, i) && is_in(b, i)) ans += i;
    }

    return ans;
}

int main() {
    std::cin >> n >> m;

    for (int i = 1; i <= m; i++) {
        int k; std::cin >> k;
        for (int j = 0; j < k; j++) {
            int t; std::cin >> t;
            mushrooms[i].push_back(t);
        }
        std::sort(mushrooms[i].begin(), mushrooms[i].end());
    }

    std::cin >> q;

    for (int i = 0; i < q; i++) {
        int a, b; std::cin >> a >> b;
        std::cout << compute_req(a, b) << std::endl;
    }
}

