#include <bits/stdc++.h>
#include "candies.h"
using namespace std;

const int MAX_N = 2 * 1e5 + 10;

int n;
int want[MAX_N];
int have[MAX_N];

int nn;
int nwant[MAX_N];
int nhave[MAX_N];

void init(vector<int> kids, const vector<int> candies) {
    n = kids.size();
    for (int i = 0; i < n; i ++) {
        want[i] = kids[i];
    }
    for (int i = 0; i < n; i ++) {
        have[i] = candies[i];
    }
}


int prev (int x, int l, int r) {
    if (x - 1 >= l) return x - 1;
    return r;
}

bool isValid(int l, int r) {
    nn = (r - l) + 1;

    for (int i = 0; i < nn; i ++) {
        nwant[i] = want[i + l];
    }

    for (int i = 0; i < nn; i ++) {
        nhave[i] = have[i + l];
    }

    for (int i = 0; i < nn; i ++) {
        int pre = prev(i, 0, nn - 1);
        int t = min(nwant[i], nhave[pre]);
        nwant[i] -= t;
        nhave[pre] -= t;
    }

    /*cout << "Wants: ";
    for (int i = 0; i < nn; i ++) {
        cout << nwant[i] << " ";
    }
    cout << endl << "Have: ";
    for (int i = 0; i < nn; i ++) {
        cout << nhave[i] << " ";
    }
    cout << endl;*/

    bool flag = true;

    for (int i = 0; i < nn; i ++) {
        if (nwant[i] == 0) continue;

        int pre = prev(i, 0, nn - 1);
        if (nhave[pre] >= nwant[i]) {
            nhave[pre] -= nwant[i];
            nwant[i] = 0;
        } else {
            flag = false;
            break;
        }
    }

    return flag;
}

void update(int l, int r, int x, int y) {
    for (int i = l; i <= r; i ++) {
        want[i] = x;
        have[i] = y;
    }
}
