#include <bits/stdc++.h>
#include "candies.h"
using namespace std;
vector<long long> a,b,c;
vector<bool> can, can1;
const long long mxN = 2e5+5;
long long n;
struct Node{
    long long left,right,sum;
    Node* leftptr, *rightptr;
    Node(long long a, long long b){
        left = a; right = b; sum = 0;
    }
    void rsize(long long rr){
        left = 0; right = rr;
    }
    void build(){
        if(left==right){
            sum = !can[left];
            return;
        }
        long long mid = left + (right-left)/2;
        leftptr = new Node(left,mid);
        rightptr = new Node(mid+1,right);
        leftptr->build();
        rightptr->build();
    }
    long long query(long long qleft, long long qright){
        if(left>qright || right<qleft){
            return 0;
        }
        if(left>=qleft && right<=qright){
            return sum;
        }
        return leftptr->query(qleft,qright)+rightptr->query(qleft,qright);
    }
} segtree(0,mxN);
void init(std::vector<int> kids, const std::vector<int> candies){
    assert(kids.size()==candies.size());
    n = kids.size();
    a.resize(n); b.resize(n); c.resize(n); can.resize(n); can1.resize(n);
    for(int i=0; i<n; i++){
        a[i]=kids[i];
        b[i]=candies[i];
        c[i]=b[i]-a[i];
    }
    if(c[n-1]<=0 || c[0]+b[n-1]>=a[n-1]){
        can[n-1]=true;
        can1[n-1]=true;
    }
    if(can[n-1]==false && b[0]+b[n-1]>=a[n-1]){
        can1[n-1]=true;
    }
    for(int i=0; i<n-1; i++){
           if(c[i]<=0 || c[i+1]+b[i]>=a[i]){
                can[i]=true;
                can1[i]=true;
           }
           if(!can[i] && b[i+1]+b[i]>=a[i]){
                can1[i]=true;
           }
    }
    segtree.rsize(n-1);
    segtree.build();
}
bool isValid(int l, int r){
    long long sum = 0;
    sum+=!can1[r];
    sum+=segtree.query(l,r-1);
    return sum==0;
}
void update(int l, int r, int x, int y){

}
