#include <bits/stdc++.h>
#define int long long
#define endl '\n'

using namespace std;

const int N = 1e5 + 5;
const int S = 1e5 + 5;
const int M = S / 2;

const int MOD = 1000000000000 + 7;

int n, m;
vector <int> in[N];

vector <int> where[N];
unordered_map <int, int> mp;

int query(int a, int b)
{
    if (a > b)
    {
        swap(a, b);
    }

    int H = a * n + b;

    H %= MOD;

    return mp[H];
}

 main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;

    ///cout << MOD << endl;

    for (int i = 0; i < m; i++)
    {
        int k;

        cin >> k;

        in[i].resize(k);

        for (int q = 0; q < k; q++)
        {
            cin >> in[i][q];

            where[in[i][q]].push_back(i);
        }

        for (int q = 0; q < k - 1; q++)
        {
            for (int j = q + 1; j < k; j++)
            {
                int a = in[i][q], b = in[i][j];

                if (a > b)
                {
                    swap(a, b);
                }

                int H = a * n + b;

                H %= MOD;

                mp[H] += i + 1LL;
            }
        }
    }

    /**for (int i = 0; i < m; i++)
    {
        for (int q = 0; q < in[i].size(); q++)
        {
            cout << in[i][q] << " ";
        }

        cout << endl;
    }**/

    int t;

    cin >> t;

    while (t--)
    {
        int a, b;

        cin >> a >> b;

        cout << query(a, b) << endl;
    }

    return 0;
}
