#include<iostream>
#include<unordered_set>
#include<unordered_map>
#include<vector>
using namespace std;

const int MAX_N = 2 * 1e5;

int n, m, q;

vector<int> baskets_by_mushroom[MAX_N];
unordered_map< long long, int > requests_cache;

int answer(int a, int b){
    if(a > b) swap(a, b);
    if(a == b) return baskets_by_mushroom[a].size();
    if(requests_cache.find(a * MAX_N + b) != requests_cache.end()){
        return requests_cache[a * MAX_N + b];
    }
    int ans = 0;
    unordered_set<int> baskets_used;
    for(int basket : baskets_by_mushroom[a]){
        baskets_used.insert(basket);
    }
    for(int basket : baskets_by_mushroom[b]){
        int prev_size = baskets_used.size();
        baskets_used.insert(basket);
        if(baskets_used.size() == prev_size)
            ans += basket;
    }
    requests_cache[a * MAX_N + b] = ans;
    return requests_cache[a * MAX_N + b];
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin >> n >> m;

    // zashtoto shapcicata broi ot 1
    for(int i = 1; i <= m; ++i){
        int k, mushroom;
        cin >> k;
        for(int j = 0; j < k; ++j){
            cin >> mushroom;
            baskets_by_mushroom[mushroom].push_back(i);
        }
    }

    cin >> q;
    for(int i = 0; i < q; ++i){
        int a, b;
        cin >> a >> b;
        cout << answer(a, b) << "\n";
    }
    return 0;
}
