#include <vector>
#include <iostream>
#include <algorithm>
#include <unordered_map>
#include<random>


using namespace std;

vector<vector<int>> tochki;

std::vector<bool> compare(int i, int j);

unordered_map< int, vector<bool> > cache;

vector<int> num_comp(1e4, 0);


vector<bool> do_compare(int i, int j){
    int key = i * 10000 + j, flipped_key = j * 10000 + i;
    if(cache.find(key) != cache.end()){

    }else if(cache.find(flipped_key) != cache.end()){
        vector<bool> ans = cache[flipped_key];
        for(int O = 0; O < ans.size(); ++O){
            ans[O] = !ans[O];
        }
        return ans;
    }else{
        cache[key] = compare(i, j);
        num_comp[i]++;
        num_comp[j]++;
    }
    return cache[key];
}

// BE WEARY OF WHICH INDEX YOU USE SMARTHEAD!!
void pivot_sort(vector<int> indecies, int amount_to_the_left, int coord){
  //  if(indecies.size() > 100) cout << "pivot sort for " << indecies.size() << endl;
    if(indecies.size() == 0){
       // cout << "EMPTY!"<< coord << endl;
        return;
    }else{
       // cout << "NOT! "<< coord << endl;
    }
    if(indecies.size() == 1){
        tochki[ indecies[0] ][coord] = amount_to_the_left;
        return;
    }

    int pivot = 0, max_comp = 0;
    for(int i = 0; i < indecies.size(); ++i){
        if(max_comp < num_comp[ indecies[i] ]){
            pivot = i;
            max_comp = num_comp[ indecies[i] ];
        }
    }

    vector<int> left, right;
    for(int i = 0; i < indecies.size(); ++i){
        if(i == pivot) continue;
        vector<bool> res = do_compare(indecies[pivot], indecies[i]);
        if(res[coord]){
            right.push_back(indecies[i]);
        }else{
            left.push_back(indecies[i]);
        }
    }
    tochki[indecies[pivot]][coord] = amount_to_the_left + left.size();

    pivot_sort(left, amount_to_the_left, coord);
    pivot_sort(right, amount_to_the_left + left.size() + 1, coord);

}


std::vector<std::vector<int>> pointSort(int n, int k){
    tochki.clear();
    cache.clear();
    for(int i = 0; i < n; ++i){
        vector<int> a;
        tochki.push_back(a);
        for(int j = 0; j < k; ++j){
            tochki[i].push_back(-1);
        }
    }
    vector<int> bla;
    for(int i = 0; i < n; ++i) { bla.push_back(i); }
    static std::mt19937 gen;
    gen.seed(2009);
    std::shuffle(bla.begin(), bla.end(), gen);


    for(int i = k - 1; i >= 0; --i){
         //   cout << i << endl;
        pivot_sort(bla, 0, i);
    }
    return tochki;
}
